{
TASK: f
LANG: PASCAL
}

type el = record
           vr : longint;
           val : extended;
          end;


const ogr = 1002;
const ogr2 = 3000;
const max_val = 1000000;


var a : array[0..ogr, 0..ogr2] of el;
    dist : array[0..ogr, 0..ogr] of double;
    heap : array[0..ogr] of el;
    c, add : array[0..ogr] of longint;
    w, sw2, vr, vr2, i, j, k, l, o, p, m, n : longint;
    sw : el;
    k1, k2, s, s1, s2, st, min, min2, max, max2 : extended;


procedure input;
var f : text;
 begin
  assign(f, '');
  reset(f);
  readln(f, n, m);
  for i := 1 to m do
    begin
     readln(f, k, l, s);
     inc(c[k]);
     a[k, c[k]].vr := l;
     a[k, c[k]].val := s;
     inc(c[l]);
     a[l, c[l]].vr := k;
     a[l, c[l]].val := s;
    end;
  close(f);
 end;


procedure goup(w : integer);
 begin
  while (w > 1) and (heap[w].val < heap[w div 2].val) do
    begin
     add[heap[w].vr] := w div 2;
     add[heap[w div 2].vr] := w;
     sw := heap[w];
     heap[w] := heap[w div 2];
     heap[w div 2] := sw;
     w := w div 2;
    end;
 end;


procedure godown(w : integer);
var k : longint;
 begin
  while w * 2 <= vr do
    begin
     k := w * 2;
     if (w * 2 + 1 <= vr) and (heap[w * 2 + 1].val < heap[w * 2].val) then k := w * 2 + 1;
     if heap[w].val <= heap[k].val then break;
     add[heap[w].vr] := k;
     add[heap[k].vr] := w;
     sw := heap[w];
     heap[w] := heap[k];
     heap[k] := sw;
     w := k;
    end;
 end;

procedure bla;
 begin
  for w := 1 to n do
    begin
     for i := 1 to n do
       begin
        heap[i].vr := i;
        heap[i].val := max_val;
        add[i] := i;
       end;
     vr := n;
     heap[w].val := 0;
     goup(w);
     while vr > 1 do
       begin
        k := heap[1].vr;
        s := heap[1].val;
        add[heap[1].vr] := vr;
        add[heap[vr].vr] := 1;
        sw := heap[1];
        heap[1] := heap[vr];
        heap[vr] := sw;
        dec(vr);
        godown(1);
        for i := 1 to c[k] do
          if (add[a[k, i].vr] <= vr) and (s + a[k, i].val < heap[add[a[k, i].vr]].val) then
            begin
             heap[add[a[k, i].vr]].val := s + a[k, i].val;
             goup(add[a[k, i].vr]);
            end;
       end;
     for i := 1 to n do
       dist[w, heap[i].vr] := heap[i].val;
    end;

  min := max_val;
  for i := 1 to n do
    begin
     max := 0;
     for j := 1 to n do
       if dist[i, j] > max then max := dist[i, j];
     if max < min then min := max;
    end;
 end;

begin
 input;

 bla;

 for i := 1 to n do
   begin
    k := i;
    for j := 1 to c[i] do
      begin
       l := a[i, j].vr;
       s := a[i, j].val;
       k1 := 0;
       k2 := 0;
       for o := 1 to n do
         if abs(dist[k, o] - (s + dist[l, o])) <= 0.000001 then
           begin
            if dist[k, o] > k1 then k1 := dist[k, o];
           end
         else
           begin
            if dist[k, o] > k2 then k2 := dist[k, o];
           end;
       if abs(k1 - k2) <= s then
         begin
          min2 := (k1 + k2) / 2;
          if min2 < min then min := min2;
         end;
      end;
   end;


 writeln(min : 0 : 4);



end.











