/*
TASK:D
LANG:C++
*/

#include <math.h>
#include <stdio.h>
#include <set>
#include <time.h>
#include <vector>
#include <utility>

using namespace std;

#define IN "d.in"
#define OUT "d.out"
#define MOD ((2<<23)-1)
#define X first
#define Y second
#define PII pair<int,int>

//set <int>  s;

vector<PII > V;

int start[MOD];

int hash (int v) {return v % MOD;}

int find (int h,int v) {
	for (int i=start[h]; i!=0; i = V[i].Y) {
		if (V[i].X == v) return 1;
	}
	return 0;
}

int push (int v) {
	int h = hash(v);
	if (find(h,v) == 0) {
		PII p;
		p.Y = start[h];
		p.X = v;
		start[h] = V.size();
		V.push_back(p);
	}
	return 0;
}

/*int run_set (int S,int M) {
	double st = clock();
	int si,sj;
	for (int i=0; i<=M; i++) {
		si = i*i;
		for (int j=0; j<=i; j++) {
			sj = j*j;
			if (si + sj > S) break;
			s.insert(si + sj);
		}
	}
	printf("%d\n",s.size() - 1);
	printf("%lf\n",(double)(clock() - st)/CLOCKS_PER_SEC);
	return 0;
}*/

int run_hash (int S,int M) {
//	double st = clock();
	int si,sj;
	for (int i=0; i<=M; i++) {
		si = i*i;
		for (int j=0; j<=i; j++) {
			sj = j*j;
			if (si + sj > S) break;	
			push(si + sj);
		}
	}
	printf("%d\n",V.size() - 2);
//	printf("%lf\n",(double)(clock() - st)/CLOCKS_PER_SEC);
	return 0;
}

int main () {
//	clock();
//	freopen(IN,"r",stdin);
//	freopen(OUT,"w",stdout);
	memset(start,0,sizeof(start));
	int S;
	scanf("%d",&S);
//	s.clear(); 
	V.push_back(make_pair(0,0));
	int M = (int)floor(sqrt(S) + 0.5 );
	  
//	run_set(S,M);
	run_hash(S,M);
	return 0;
}
