/*
TASK:f
LANG:C
*/

#include <stdio.h>
#include <string.h>

short n, m, paths[2900][2];
double g[1001][1001], dist[1001][1001], pd[1001];

void input(void)
{
	short i, x, y;
	double l;
	scanf("%hd %hd", &n, &m);
	for(x=0; x<n; ++x)
		for(y=0; y<n; ++y)
			g[x][y]=dist[x][y]=0;
	for(i=0; i<m; ++i)
	{
		scanf("%hd %hd %lf", &x, &y, &l);
		--x; --y;
		g[x][y]=g[y][x]=dist[x][y]=dist[y][x]=l;
		paths[i][0]=x;
		paths[i][1]=y;
	}
}

void dij(short i)
{
	static short j, b;
	static char visited[1001];
	memset(visited, 0, 1001);
	visited[i]=1;
	while(1)
	{
		for(b=0; b<n && (visited[b] || !dist[i][b]); ++b);
		if(b==n)
			break;
		for(j=b+1; j<n; ++j)
			if(!visited[j] && dist[i][j] && dist[i][j]<dist[i][b])
				b=j;
		visited[b]=1;
		for(j=0; j<n; ++j)
			if(j!=i && g[b][j] && dist[i][b] && (!dist[i][j] || dist[i][j]>dist[i][b]+g[b][j]))
				dist[i][j]=dist[i][b]+g[b][j];
	}
}

void initpd(short i, short j, double *mi, double *mj)
{
	static short c;
	*mi=*mj=0;
	for(c=0; c<n; ++c)
		if(dist[i][c]<dist[j][c])
		{	
			if(dist[i][c]>*mi)
				*mi=dist[i][c];
		}
		else
		{
			if(dist[j][c]>*mj)
				*mj=dist[j][c];
		}
}

int main(void)
{
	short i;
	double x, y, a1, t, best=9000000;
	input();
	for(i=0; i<n; ++i)
		dij(i);
	for(i=0; i<m; ++i)
	{
		initpd(paths[i][0], paths[i][1], &x, &y);
		a1=(y+g[paths[i][0]][paths[i][1]]-x)/2;
		if(a1<=0)
			t=x;
		if(a1>=g[paths[i][0]][paths[i][1]])
			t=y;
		if(a1>0 && a1<g[paths[i][0]][paths[i][1]])
			t=x+a1;
		if(t<best)
			best=t;
	}
	printf("%.4lf\n", best);
	return 0;
}

