// N. Nikolova

#include<iostream>
using namespace std;

int a1,a2,b1,b2,c1,c2,m1,m2;
int n;

int OneHalf(double a1,double a2, double b1,double b2, double c1, double c2, double m1, double m2){

//   "TRUE",   C i M     
//   AB       AB
//  "FALSE" -   

	double f=(a2-b2)*c1+(b1-a1)*c2+a1*b2-a2*b1;
	double g=(a2-b2)*m1+(b1-a1)*m2+a1*b2-a2*b1;

	return f*g >= 0;
}

int IsInTriangle(int m1,int m2){

// "TRUE",   M    
//     ABC

	return OneHalf(a1,a2,b1,b2,c1,c2,m1,m2)&&
		   OneHalf(a1,a2,c1,c2,b1,b2,m1,m2)&&
		   OneHalf(c1,c2,b1,b2,a1,a2,m1,m2);
}

int main(){
	
	cin>>a1>>a2>>b1>>b2>>c1>>c2;
	cin>>n;
	
	int cnt = 0; //  ,   

	for (int i=1; i<=n; i++)
	{
		cin>>m1>>m2;
		if (IsInTriangle(m1,m2))
			cnt++;
	}
	
	cout << cnt << endl;

	return 0;
}
