// S. Kapralov

#include <iostream>
#include <vector>
using namespace std;

int n,m;  
vector<int> a[128]; // 
int visited[128]; //visited[i] = 0,  i-    
		              //visited[i] = 1, ako i-   

void init()
{ cin>>n>>m;
  for (int i=1; i<=m; i++)
  { int u,v;
    cin >> u >> v;
    a[u].push_back(v);
    a[v].push_back(u);
  }
}

void dfs(int u)
{ visited[u] = 1; 
  for (int i=0; i<a[u].size(); i++)
  { int v = a[u][i];
    if (visited[v]==0)
    { visited[v] = 1;
	dfs(v);
    }
  } 
}

int main()
{ init();
  int cnt = 0;
  for(int u=1; u<=n; u++)
    if(visited[u]==0)
    { cnt++; dfs(u); }
  cout << cnt-1 << endl;
  return 0;
}
