program SEGMENT;
uses
 crt;

type
 tochka=record
  x,y:longint;
 end;
 prava=record
  t1,t2:tochka;
  a,b:real;        {uravnenie na prava: y=ax+b}
  vertical:boolean;
 end;

var
 AB,AC,BC,MN:prava;
 X,E,F:tochka;
 Intersections,er:byte;
 L:real;

procedure FindUravn(var p:prava);
begin
 with p do
  if t1.x=t2.x then
   vertical:=true else begin
   a:=(t1.y-t2.y)/(t1.x-t2.x);
   b:=t1.y-a*t1.x;
   vertical:=false;
  end;
end;

procedure FindIntersection(p1,p2:prava; var t:tochka;var error:byte);
begin
 error:=0;
 if (p1.vertical) and (not p2.vertical) then begin
  t.x:=p1.t1.x;
  t.y:=round(p2.a*t.x+p2.b);
 end;
 if (not p1.vertical) and (p2.vertical) then begin
  t.x:=p2.t1.x;
  t.y:=round(p1.a*t.x+p1.b);
 end;
 if (not p1.vertical) and (not p2.vertical) then begin
  if p1.a=p2.a then
   if p1.b=p2.b then
    error:=2 else
    error:=1
  else begin
   t.x:=round((p2.b-p1.b)/(p1.a-p2.a));
   t.y:=round(p1.a*t.x+p1.b);
  end;
 end;
 if (p1.vertical) and (p2.vertical) then
  if p1.t1.x<>p2.t2.x then
   error:=1 else
   error:=2;
end;

function FindLength(t1,t2:tochka):real;
begin
 FindLength:=sqrt(sqr(t1.x-t2.x)+sqr(t1.y-t2.y));
end;

begin
 clrscr;
 readln(AB.t1.x,AB.t1.y,AB.t2.x,AB.t2.y,AC.t2.x,AC.t2.y,MN.t1.x,MN.t1.y,MN.t2.x,MN.t2.y);
 writeln;

 AC.t1.x:=AB.t1.x;
 AC.t1.y:=AB.t1.y;
 BC.t1.x:=AB.t2.x;
 BC.t1.y:=AB.t2.y;
 BC.t2.x:=AC.t2.x;
 BC.t2.y:=AC.t2.y;

 FindUravn(AB);
 FindUravn(AC);
 FindUravn(BC);
 FindUravn(MN);

 E.x:=0;
 E.y:=0;
 F.x:=0;
 F.y:=0;

 Intersections:=0;

 FindIntersection(AB,MN,X,er);
 if er=2 then begin
  E.x:=AB.t1.x;
  E.y:=AB.t1.y;
  F.x:=AB.t2.x;
  F.y:=AB.t2.y;
  Intersections:=2;
 end else if er=0 then
  if ((X.x>=AB.t1.x) and (X.x<=AB.t2.x)) or ((X.x<=AB.t1.x) and (X.x>=AB.t2.x)) then begin
   Intersections:=1;
   E:=X;
  end;
 FindIntersection(AC,MN,X,er);
 if er=2 then begin
  E.x:=AC.t1.x;
  E.y:=AC.t1.y;
  F.x:=AC.t2.x;
  F.y:=AC.t2.y;
  Intersections:=2;
 end else if er=0 then
  if ((X.x>=AC.t1.x) and (X.x<=AC.t2.x)) or ((X.x<=AC.t1.x) and (X.x>=AC.t2.x)) then
   case Intersections of
    0:begin
     Intersections:=1;
     E:=X
    end;
    1:begin
     Intersections:=2;
     F:=X;
    end;
   end;
 FindIntersection(BC,MN,X,er);
 if er=2 then begin
  E.x:=BC.t1.x;
  E.y:=BC.t1.y;
  F.x:=BC.t2.x;
  F.y:=BC.t2.y;
  Intersections:=2;
 end else if er=0 then
  if ((X.x>=BC.t1.x) and (X.x<=BC.t2.x)) or ((X.x<=BC.t1.x) and (X.x>=BC.t2.x)) then
   case Intersections of
    0:begin
     Intersections:=1;
     E:=X;
    end;
    1:begin
     Intersections:=2;
     F:=X;
    end;
   end;

 if Intersections=2 then
  L:=FindLength(E,F) else
  L:=0;

 writeln(L:0:5);
 readln;
end.