#include <iostream>
#include <stdio.h>
#include <cmath>
using namespace std;
typedef struct point
{
  double x;
  double y;
};
double min_(double a, double b)
{
  return ((a<b)?a:b);
}
double max_(double a, double b)
{
  return ((a>b)?a:b);
}
double l_a(point a, point b)
{
  return sqrt((b.x-a.x)*(b.x-a.x)+(b.y-a.y)*(b.y-a.y));
}
double l_a_p(double x1, double y1, double x2, double y2)
{
  return sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
}
double f(point a, point b)
{
  return ((b.y-a.y)/(b.x-a.x));
}
double f_p(double x1, double y1, double x2, double y2)
{
  return ((y2-y1)/(x2-x1));
}
double k(point a, point b)
{
  return (b.y-f(a,b)*b.x);
}
double k_p(double x1, double y1, double x2, double y2)
{
  return (y2-f_p(x1,y1,x2,y2)*x2);
}

int main()
{
  point a,b,c, x,y;
  double ox[3], oy[3];
  double res=0.0;
  cin>>a.x>>a.y>>
       b.x>>b.y>>
       c.x>>c.y>>
       x.x>>x.y>>
       y.x>>y.y;
  // y=f.x + k
  if(a.x==b.x==x.x==y.x) res=l_a(a,b);
  else
    if(c.x==b.x==x.x==y.x) res=l_a(c,b);
    else
      if(a.x==c.x==x.x==y.x) res=l_a(a,c);
      else
        if(x.x==y.x && a.x==b.x && c.x>x.x && x.x>a.x)
	  res=l_a_p(x.x, x.x*f(c,b)+k(c,b), x.x, x.x*f(a,c)+k(a,c));
        else
          if(x.x==y.x && a.x==b.x && c.x<x.x && x.x<a.x)
            res=l_a_p(x.x, x.x*f(c,b)+k(c,b), x.x, x.x*f(a,c)+k(a,c));
          else
            if(x.x==y.x && c.x==b.x && a.x>x.x && x.x>c.x)
              res=l_a_p(x.x, x.x*f(a,c)+k(a,c), x.x, x.x*f(c,b)+k(c,b));
            else
              if(x.x==y.x && c.x==b.x && a.x<x.x && x.x<c.x)
		res=l_a_p(x.x, x.x*f(a,c)+k(a,c), x.x, x.x*f(a,b)+k(a,b));
	      else
		if(x.x==y.x && a.x==c.x && b.x>x.x && x.x>a.x)
		  res=l_a_p(x.x, x.x*f(a,b)+k(a,b), x.x, x.x*f(b,c)+k(b,c));
		else
		  if(x.x==y.x && a.x==c.x && b.x<x.x && x.x<a.x)
		    res=l_a_p(x.x, x.x*f(a,b)+k(a,b), x.x, x.x*f(b,c)+k(b,c));
		  else
		    if( (a.x!=b.x) )
		    {
		      if( f(a,b) == f(x,y)  && ( k(a,b) == k(x,y) ) ) res=l_a(a,b);
		    }
		    else if( (b.x!=c.x) )
		    {
		      if ( f(b,c) == f(x,y)  && ( k(b,c) == k(x,y) ) ) res=l_a(b,c);
		    }
		    else if( (a.x!=c.x) )
		    {
		      if( f(a,c) == f(x,y)  && ( k(a,c) == k(x,y) ) ) res=l_a(a,c);
		    }
		    else if(res!=0.0)
		    {
			  if(f(a,b)-f(x,y)!=0)
			    ox[0] = (k(x,y)-k(a,b))/(f(a,b)-f(x,y));
			  if(f(c,b)-f(x,y)!=0)
			    ox[1] = (k(x,y)-k(c,b))/(f(c,b)-f(x,y));
			  if(f(a,c)-f(x,y)!=0)
			    ox[2] = (k(x,y)-k(a,c))/(f(a,c)-f(x,y));
			  if(f(a,b)-f(x,y)!=0 && f(c,b)-f(x,y)!=0)
			  {  if((ox[0]>min_(a.x,b.x))&&(ox[0]<max_(a.x,b.x)))
			      if((ox[1]>min_(c.x,b.x))&&(ox[1]<max_(c.x,b.x)))
				res=l_a_p(ox[0],ox[0]*f(x,y)+k(x,y),ox[1],ox[1]*f(x,y)+k(x,y));
			  }
			  else if(f(a,b)-f(x,y)!=0 && f(c,a)-f(x,y)!=0)
			  {  if((ox[0]>min_(a.x,b.x))&&(ox[0]<max_(a.x,b.x)))
			       if((ox[2]>min_(c.x,a.x))&&(ox[2]<max_(c.x,a.x)))
				 res=l_a_p(ox[0],ox[0]*f(x,y)+k(x,y),ox[2],ox[2]*f(x,y)+k(x,y));
			  }
			  else if(f(c,b)-f(x,y)!=0 && f(c,a)-f(x,y)!=0)
			  {
			     if((ox[1]>min_(c.x,b.x))&&(ox[1]<max_(c.x,b.x)))
			       if((ox[2]>min_(c.x,a.x))&&(ox[2]<max_(c.x,a.x)))
				 res=l_a_p(ox[1],ox[1]*f(x,y)+k(x,y),ox[2],ox[2]*f(x,y)+k(x,y));
			  }
			}
  printf("%.4f\n",res);
  return 0;


}
