/* Petar Ivelinov Ivanov, Shumen, A */

#include <stdio.h>

typedef long long type;

struct elem { type num; int prev, br; };

type a, p;
elem Q[1000];
int min=99999, optimalDigit;

int V[10000], r;

int digitCount (int p, int lamp)
{
   if (Q[p].prev == -1) return 1;
   return digitCount(Q[p].prev, (Q[p].br?1:0)||lamp) + lamp;
}

int check (int q)
{
   int i;

   for (i=0; i<r; i++)
      if (V[i]==q)
         return 1;

   return 0;
}

void bfs (int firstNum, int digit)
{
   int i, q, f=0, l=1, res;
   type newnum;

   Q[0].num  = firstNum;
   Q[0].br   = firstNum/a;
   Q[0].prev = -1;

   while (f<l) {
      q = Q[f].num;

      if (!check(q)) {
         for (i=0; i<p; i++) {
            newnum = q/p+i*a;

            if (newnum == 0) {
               res = digitCount (f,Q[f].num?1:0);
               if (min>res) {
                  min = res;
                  optimalDigit = digit;
               }
            }


            if (newnum%p == digit) {
               Q[l].num  = newnum;
               Q[l].br   = i;
               Q[l].prev = f;

               l++;
            }
         }

         V[r++]=q;
      }
      
      f++;
   }
}

void solve ()
{
   int i;

   for (i=1; i<p; i++) {
      r=0;
      bfs (i*a, (i*a)%p);
   }
}

int main ()
{
   scanf ("%d%d", &a, &p);
   
   solve ();

   if (min==99999) printf ("0\n");
   else printf ("%d %d\n", min, optimalDigit);

   return 0;
}
