#include <stdio.h>
#define MAX 46

__int64 F[MAX][4]; /* (0 - K), (1 - A), (2 - O), (3 - E) */
__int64 sum[MAX];

int main(void)
{
    __int64 s;
    int i, j;
    
    /* get input */
    scanf("%I64d", &s); 
    
    /* init F[][] */
    F[1][0] = 1;
    F[1][1] = 1;
    F[1][2] = 1;
    F[1][3] = 1;
    
    F[2][0] = 3;
    F[2][1] = 1;
    F[2][2] = 3;
    F[2][3] = 3;
    
    /* dance (DP) */
    for(i = 3; i < MAX; i++) {
          F[i][0] = F[i - 1][1] + F[i - 1][2] + F[i - 1][3];
          F[i][1] = F[i - 1][0];
          F[i][2] = F[i - 1][0] + F[i - 1][1] + F[i - 2][0];
                    /*(F[i - 1][3] - (F[i - 2][1] + F[i - 2][2]));*/
          F[i][3] = F[i][2];
    }
    /* init sum[] */
    sum[0] = 0;
    for(i = 1; i < MAX; i++) {
          sum[i] = F[i][0] + F[i][1] + F[i][2] + F[i][3] + sum[i - 1];
          if(sum[i] - 1 >= s) break;
    }
    printf("%d\n", i);
    
    return 0;
}
