/*
FROM: NOI2 2006 A
PROB: ident
KEYW: mathematics, mod
*/

#include <cstdio>

const int MAXA = 1 << 20;
const int _infinity = 1 << 7;//more than the MAXP

int A, P;
int opt[MAXA];
bool used[MAXA];

int main () {
	scanf ("%d %d", &A, &P);
    if (P == 1) {
    	printf ("0\n");//just in case
        return 0;
    }

	int i, j;
	for (i = 0; i < A; ++i) opt[i] = _infinity;
	for (i = 0; i <= P-2; ++i)
		for (j = i + 1; j < P; ++j)
			if (!((i * A) % j) && opt[i * A / j] > j)
				opt[i * A / j] = j;

	int crnt = 1 % A;//in case A is 1
	int n = 1;
	while (!used[crnt] && opt[crnt] == _infinity) {
		used[crnt] = 1;
		crnt = (crnt * P + 1) % A;
		++n;
//        printf (" %d %d\n", n, crnt);
	}

	if (used[crnt]) printf ("0\n");//no solution
	else 			printf ("%d %d\n", n, opt[crnt]);//solution

	return 0;
}

