#include <stdio.h>
#include <stdlib.h>

#define MAX 100000

int powers[MAX] = { 0 };

int power(int x, int y) {
	int i, result;
	result = 1;
	
	if (powers[y] > 0) {
 	   return powers[y];
    }
	
	for (i = 0; i<y; i++) {
		result *= x;	
	}
	
	powers[y] = result;	
	return result;
}

void convert(int a, int p, char *dest) {
	 int i, x, v;
	 
	 x = a;
	 
	 while (x > 0) {
         i = 0;	 	   
	 	   
	 	 while (power(p, i) <= x) {
		 	   i++;
	     }
	     
	     printf("%d ", (int)(x / power(p, i - 1)));
	     v = (x / power(p , i - 1));
	     x -= v * power(p , i - 1);
	 }
	 
	 for (; i>1; i--) {
	 	 printf("0 ");	 
	 }
	 
	 printf("\n");
}

int nod(int x, int y) {

	int a = (x < y ? x : y);
	int b = (x < y ? y : x);
	
	if (a == b || b % a == 0) return a;
	
	return nod(b % a, a);
}

int main() {
	int a, p, k;
	char st[100];
	int last, i, j;
	int x, y;
	int base[MAX];
	int used[MAX] = { 0 };
	int usedCount = 0;
	
	scanf("%d %d", &a, &p);
	//convert(a, p, st);
	
	base[0] = 0;
	base[1] = 1;
	
	for (i=2; i<MAX; i++) {
		base[i] = base[i - 1] + power(p, i-1);
		
		k = (base[i] / nod(base[i], a));
		x = (a / nod(base[i], a));
		
//  		if (used[x % p]) break;
//		used[x % p] = 1;
		
		if (x >= p || base[i] * x >= power(p, i)) {
		   for (j = 0; j<usedCount; j++) {
		   	   if (used[j] == x) break;
		   }
		   if (used[j] == x && a < power(p, i)) break;
		   
		   used[usedCount] = x;
		   usedCount ++;

  		   continue;
  		} else {
		   printf("%d %d\n", i, x);
		   return;
	    }
	}
	
	printf("0\n");
	
	return 0;
}
