/* Veselin Kulev */

#include <stdio.h>

#define IN "meet.in"
#define OUT "meet.out"

#define MAXN (1<<17)

int prev[MAXN] = {};
int vis[MAXN] = {};

int solve (int a,int b) {
	int olda = a;
    vis[0] = 1;

    while (a != 0) {
    	vis[a] = 1;
        a = prev[a];
    }

    while (vis[b] == 0) {
    	b = prev[b];
    }
    printf("%d\n",b);

    a = olda;
    while (a != 0) {
    	vis[a] = 0;
        a = prev[a];
    }

    return 0;
}

int main () {
    int N,M;
    scanf("%d%d",&N,&M);
    for (int i=1; i<=N; i++) scanf("%d",&prev[i]);
    for (int i=1; i<=M; i++) {
    	int a,b;
        scanf("%d%d",&a,&b);
        solve (a,b);
    }
    return 0;
}

