#include <iostream>
#include <set>
#include <vector>
#include <queue>
#include <ctime>
#include <ext/numeric>
#include <ext/algorithm>

#define f(i,n) for(int i = 0 ; i < (n) ; i ++)
#define fx(it,v) for(typeof( (v).begin() ) it = (v).begin(); it != (v).end(); it ++)
#define all(a) (a).begin(), (a).end()

#define x first
#define y second
#define mp make_pair
#define pb push_back

int n,m;
std::vector<int> a[10005];

bool used[10005];
int bfs(int st)
{
	int res = 0;
	std::queue<int> q;
//	std::cout << st << " st\n";
	used[st] = 1;
	q.push(st);
	while(!q.empty())
	{
		int cur = q.front(); q.pop();
//		std::cout << cur << "\n";
		for(int i = 0; i < a[cur].size(); i ++)
		{
//			std :: cout << a[cur][i] << "\n";
			res ++;
			if( !used[ a[cur][i] ] )
			{
				q.push(a[cur][i]);
				used[ a[cur][i] ] = 1;
			}
		}
	}
	return res >> 1;
}


int main()
{
	scanf("%d %d", &n, &m);
	f(i,m)
	{
		int p,q;
		scanf("%d %d", &p, &q);
		a[p].pb(q);
		a[q].pb(p);
	}
	
	int res = 0;
	for(int i = 1; i <= n; i ++)
		if(!used[i])
		{
			int t = bfs(i);
			res = std::max(res,t);
//			std::cout << i << " " << t << "\n";
		}
	printf("%d\n",res);
    return 0;
}
