#include <stdio.h>
#include <algorithm>
using namespace std;

struct Vertex
{
       int u, next;
       Vertex(){}
       Vertex(int _u, int _next):u(_u), next(_next){}
} nodes[2000000];
int cnt;
int table[10000];
int lowest[10000];
int N, M;

void add(int a, int b)
{
     nodes[cnt] = Vertex(b, table[a]);
     table[a] = cnt++;
}

int br;
int root;
bool art[10000];
int begin;
void DFS(int k)
{
     lowest[k] = br++;
     for (int v = table[k]; v != -1; v = nodes[v].next)
      if (lowest[nodes[v].u] == -1) 
      {
           if (k == begin) root++; 
           DFS(nodes[v].u);
           
           if (k != begin && lowest[nodes[v].u] == lowest[k]) art[k] = 1;
      }
     
     for (int v = table[k]; v != -1; v = nodes[v].next) 
      lowest[k] = min(lowest[k], lowest[ nodes[v].u ]);
}

void intput()
{
     scanf("%d %d", &N, &M);
     for (int i = 0; i < M; i++)
     {
         int a, b;
         scanf("%d %d", &a, &b);
         a--;b--;
         add(a, b); add(b, a);
     }
}

int comp[10000];
int C; 
bool used[10000];

int DFS2(int k)
{
    used[k] = 1;
    comp[k] = C;
    
    for (int v = table[k]; v != -1; v = nodes[v].next) 
     if (!used[nodes[v].u])  DFS2(nodes[v].u);
}

int Ribs[10000];

int main()
{
    memset(table, -1, sizeof(table));
    memset(lowest, -1, sizeof(lowest));
    intput();
    
    for (int i = 0; i < N; i++) if (lowest[i] == -1)
    {
        root = 0;
        begin = i;
        DFS(i);
        if (root > 1) art[i] = 1;
    }
    
    for (int i = 0; i < N; i++) if (art[i]) used[i] = 1;
    
    for (int i = 0; i < N; i++) if (!used[i])
    {
        C++;
        DFS2(i);
    }
    
    for (int i = 0; i < N; i++)
     for (int v = table[i]; v != -1; v = nodes[v].next)
      if (!art[i] && !art[nodes[v].u] && comp[i]==comp[nodes[v].u]) Ribs[comp[i]]++;
      else if (art[i]^art[nodes[v].u])
      {
           if (art[i]) 
           //{ for (int v1 = table[i]; v1 != -1; v1 = nodes[v1].next)
           //  if (comp[nodes[v1].u] == comp[nodes[v].u] && nodes[v1].u != nodes[v].u) 
             //{  
             Ribs[comp[nodes[v].u]]++; 
             //break; }}
           else
           // for (int v2 = table[nodes[v].u]; v2 != -1; v2 = nodes[v2].next)
           //  if (comp[nodes[v2].u] == comp[i] && nodes[v2].u != i)
           //  {
             Ribs[comp[i]]++;
             //break;}
      }
      else if (art[i] && art[nodes[v].u])
      {
           int T[C+1];
           memset(T, 0, sizeof(T));
           
           for (int v1 = table[i]; v1 != -1; v1 = nodes[v1].next)
            T[comp[nodes[v1].u]] |= 1;
             
           for (int v2 = table[nodes[v].u]; v2 != -1; v2 = nodes[v2].next)
            T[comp[nodes[v2].u]] |= 2;
           
           for (int i = 1; i <= C; i++) if (T[i] == 3)
            Ribs[i]++;
      }
    
    //for (int i = 0; i < N; i++) printf("%d: %d\n", i+1, comp[i]);
    int maxx = 0;  
    for (int i = 1; i <= C; i++)
     maxx = max(maxx, Ribs[i]);
     
    printf("%d\n", maxx/2);
    return 0;
}
