#include <cstdio>
#include <vector>
#include <queue>
#define maxN 10005

using namespace std;
vector <int> G[maxN];
int n,m,h=20000,best=0;
int prenum[maxN], lowest[maxN], used[maxN], f[maxN], num;
char art[maxN];
queue <int> q;

void input()
{
     int i,a,b;
     scanf("%d%d",&n,&m);
     for (i=1;i<=n;++i) G[i].reserve(200);
     for (i=0;i<m;++i) {
         scanf("%d%d",&a,&b);
         G[a].push_back(b);
         G[b].push_back(a);
         if (a < h) h = a;
         }
}

void dfs(int p)
{
     used[p] = 1;
     int i;
     prenum[p] = ++num;
     lowest[p] = prenum[p];
     for (i=0;i<G[p].size();++i) {
         if (!used[G[p][i]]) {
            f[G[p][i]] = p;
            dfs(G[p][i]);
            if (lowest[p] > lowest[G[p][i]]) lowest[p] = lowest[G[p][i]];
            }
         if (G[p][i] != f[p]) 
            if (lowest[p] > prenum[G[p][i]]) lowest[p] = prenum[G[p][i]];
         }
}

void artic(int s)
{
     int i,br=0,j;
     for (i=1;i<=n;++i) prenum[i] = 20000;
     dfs(s); f[s] = s;
     for (i=0;i<G[s].size();++i) if (f[G[s][i]]==s) ++br;
     if (br > 1) art[s] = 1;
     for (i=1;i<=n;++i) if (i != s)
         for (j=0;j<G[i].size();++j) if (G[i][j] != f[i]) if (f[G[i][j]] == i)
             if (prenum[i] <= lowest[G[i][j]]) art[i] = 1;
}

void bfs(int s, int br)
{
     int i,j,p,ans=0;
     q = queue<int>();
     q.push(s); used[s] = br;
     while (!q.empty()) {
           p = q.front(); q.pop();
           if (art[p]) continue;
           for (i=0;i<G[p].size();++i) if (used[G[p][i]]==0 || art[G[p][i]]) {
               q.push(G[p][i]);
               used[G[p][i]] = br;
               }
           }
     for (i=1;i<=n;++i) if (used[i] == br)
         for (j=0;j<G[i].size();++j) if (used[G[i][j]]==br) ans++;
     ans /= 2;
     if (ans > best) best = ans;
}

int main()
{
    input();
    artic(h);
    for (int i=1;i<=n+2;++i) used[i] = 0;
    for (int i=1;i<=n;++i) if (used[i] == 0) bfs(i,i);
    printf("%d\n",best);
    return 0;
}
