/*
TASK:bicon
LANG:C++
*/
#include <iostream>
#include <fstream>
#include <vector>
#include <bitset>
#include <iomanip>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <functional>
#include <utility>
#include <numeric>
#include <sstream>
#include <string>

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define SZ size()
#define MP make_pair
#define PB push_back
#define x first
#define y second
#define IT iterator
#define VI vector<int>
#define ALL(v) v.begin(),v.end()
#define PI pair<int,int>

using namespace std;

int N,M;
#define MAXN 20000
int high[MAXN],ret[MAXN],lev[MAXN];
VI adj[MAXN],cost[MAXN];
int ans;

void solve(int v,int level)
{
    lev[v]=high[v]=level;
    //cout<<"in "<<v<<" - "<<level<<endl;
    int w;
    Repi(adj[v].SZ)
     {
                   w=adj[v][i];
                   if (!lev[w])
                    {
                        // cout<<"from "<<v<<" to "<<w<<endl;
                         solve(w,level+1);
                         if (high[w]>=level) //artikulacionna
                          {
                                            ans=max(ans,ret[w]+1/*+cost[v][i]*/);
                                    //        cout<<v<<" "<<w<<" - "<<ans<<" >?= "<<ret[w]+1<<endl;
                          }
                         else
                          {
                           high[v]=min(high[v],high[w]); 
                           ret[v]+=ret[w]+1; //+cost[v][i]; 
                          }
                    }
                   else
                    if (lev[w]<lev[v]-1)
                     {
                      high[v]=min(high[v],lev[w]);
                      ret[v]++; //+=cost[v][i];
                    //  cout<<v<<" to "<<w<<endl;
                     }
     }
   //  cout<<v<<" "<<ret[v]<<endl;
   // cout<<"out "<<v<<" = "<<high[v]<<" "<<level<<"   ; "<<ret[v]<<endl;
}

inline void addedge(int u,int v,int c)
{ adj[u].PB(v);
  adj[v].PB(u);
  //cost[u].PB(c);
  //cost[v].PB(c);
}




int mask,cnt,cnte,stava;
int hah[25],le[25];
void dfs(int v,int lev)
{
     hah[v]=le[v]=lev;
     cnt++;
     Repi(adj[v].SZ)
      {
       int w=adj[v][i];
       if (!le[w] && mask&(1<<(w-1)))
        {
                  dfs(w,lev+1);
                  if (hah[w]>=lev && lev>1)
                    stava=0;
                  hah[v]<?=hah[w];
                  cnte++; //+=cost[v][i];
        }
       else if (le[w] && le[w]<le[v]-1)
        {
         hah[v]<?=le[w];
         cnte++; //+=cost[v][i];
        }
      }
      if (hah[v]==lev && lev>1)stava=0;
}


//pri 1 rebro izkarva 0
void brute()
{
    int ans=0;
   // mask=(1<<N)-1;
   mask=31-4;
   mask=5;
    for (mask=1;mask<(1<<N);mask++)
     {
             memset(hah,0,sizeof(hah)); memset(le,0,sizeof(le));
             cnt=cnte=0; stava=1;
             Repi(N)
              if (mask&(1<<i) && !hah[i+1])
               { dfs(i+1,1); break; }
           if (cnt<__builtin_popcount(mask) || !stava) continue;
             ans>?=cnte;
            // cout<<bitset<14>(mask)<<" "<<cnt<<" "<<cnte<<" "<<stava<<endl;
     }
     cout<<ans<<endl;
}

int main()
{
    int i,j,k,l;
    scanf("%d%d",&N,&M);
    vector<PI> E(M);
    Repi(M)
     {
           scanf("%d%d",&E[i].x,&E[i].y);
           addedge(E[i].x,E[i].y,1);
  //         if (E[i].x>E[i].y) swap(E[i].x,E[i].y);
     }
   /* sort(ALL(E));
    int last=0; i=0;
    while(i<M)
     {
              while (i<M && E[i]==E[last]) i++;
              addedge(E[last].x,E[last].y,i-last);
              last=i;
      }*/
     
    Repi(N+1)
     if (!lev[i]) solve(i,1);
     
    cout<<ans<<"\n";
    
    //brute();
    
    return 0;
}
