#include<cstdio>
#include<queue>
using namespace std;

//int tab[1024][1024];
int d[1024][1024];

void bfs(int i, int j)
{
    //printf("BFS-beg\n");
    queue<int> row, col;
    row.push(i); col.push(j);
    d[i][j]=0;
    int r, c;
    while(!row.empty())
    {
        r=row.front(); row.pop();
        c=col.front(); col.pop();
        //printf("%d %d\n", r, c);
        if(!d[r-1][c-1])
        {
            d[r-1][c-1]=d[r][c]+1;
            row.push(r-1);
            col.push(c-1);
        }
        if(!d[r-1][c])
        {
            d[r-1][c]=d[r][c]+1;
            row.push(r-1);
            col.push(c);
        }
        if(!d[r][c-1])
        {
            d[r][c-1]=d[r][c]+1;
            row.push(r);
            col.push(c-1);
        }
        if(!d[r][c+1])
        {
            d[r][c+1]=d[r][c]+1;
            row.push(r);
            col.push(c+1);
        }
        if(!d[r+1][c])
        {
            d[r+1][c]=d[r][c]+1;
            row.push(r+1);
            col.push(c);
        }
        if(!d[r+1][c+1])
        {
            d[r+1][c+1]=d[r][c]+1;
            row.push(r+1);
            col.push(c+1);
        }
    }
    //printf("BFSend\n");
}

int main()
{
    int r, c;
    scanf("%d%d", &r, &c);
    int i, j;
    for(i=0; i<=r+1; i++)
        for(j=0; j<=c+1; j++)
            d[i][j]=1;
    char t;
    int rr, cr, rm, cm;
    for(i=1; i<=r; i++)
        for(j=1; j<=c; j++)
        {
            scanf("%c", &t);
            if(t=='\n') scanf("%c", &t);
            if(t=='0') d[i][j]=0;
            else if(t=='1') d[i][j]=1;
            else if(t=='B')
            {
                //printf("Rabotnik: %d %d\n", i, j);
                d[i][j]=0;
                rr=i;
                cr=j;
            }
            else
            {
                //printf("Maika: %d %d\n", i, j);
                d[i][j]=0;
                rm=i;
                cm=j;
            }
        }
    /*
    for(i=0; i<=r+1; i++)
    {
        for(j=0; j<=c+1; j++)
            printf("%d ", d[i][j]);
        printf("\n");
    }
    */
    bfs(rr, cr);
    //printf("%d %d\n", rm, cm);
    if(d[rm][cm])printf("%d\n", d[rm][cm]);
    else printf("-1\n");
    return 0;
}
