#include <iostream>
using namespace std;

int k[1001], n;

void Qsort( int low, int high )
{
    int i = low, j = high, h;
    int x = k[ ( i + j )/2 ];
    
    do
    {
        while ( k[i] > x )
              i++;
        while ( k[j] < x )
              j--;
        
        if ( i <= j )
        {
             h = k[i];
             k[i] = k[j];
             k[j] = h;
             
             i++;
             j--;
        }
    }
    while ( i <= j );
    
    if ( i < high )  Qsort( i, high );
    if ( low < j )   Qsort( low, j );
}

void swap( int a, int b )
{
     int h;
     h = k[a];
     k[a] = k[b];
     k[b] = h;
}

int main()
{
    int i, j;
    int v = 0, brnull = 0;
    
    cin >> n;
    for ( i = 1; i <= n; i++ )
        cin >> k[i];
    
    Qsort( 1, n );
    
    while ( brnull < n - 1 )
    {
        if ( ( k[1] != 0 ) && ( k[2] != 0 ) )
        {
            k[1]--;
            k[2]--;
            v++;
        }
        else break;
        
        if ( k[1] == 0 )
           brnull++;
        if ( k[2] == 0 )
           brnull++;
        
        i = 3;
        while ( ( k[2] < k[i] ) && ( i < n ) )
              i++;
        if ( k[2] < k[i] )
           swap( 2, i );
        else if ( k[2] < k[i-1] )
             swap( 2, i-1 );
        
        i = 2;
        while ( ( k[1] < k[i] ) && ( i < n ) )
              i++;
        if ( k[1] < k[i] )
           swap( 1, i );
        else if ( k[1] < k[i-1] )
             swap( 1, i-1 );
    }

    cout << v << endl;
//    system( "pause" );
}
