/*
TASK: lucky
LANG: C++
*/

#include <cstdio>
#include <iostream>

#define f(i, n) for(int i = 0; i < (n); i ++)
#define ff(i, st, end) for(int i = (st); i < (end); i ++)
#define fv(i, v) for(int i = 0; i < int((v).size()); i ++)
#define fx(i, v) for(typeof( (v).begin() ) it = (v).begin(); it != (v).end(); it ++)
#define all(v) (v).begin(), (v).end()

bool lucky(long long a)
{
	long long sum = 0, prod = 1;
	while(a)
	{
		sum += a % 10;
		prod *= a % 10;
		a /= 10;
	}
	return (prod % sum == 0);
}

long long Sum[100025], Prod[100025];

void init(int a)
{
	long long sum = 0, prod = 1, bu = a;
	while(a)
	{
		sum += a % 10;
		prod *= a % 10;
		a /= 10;
	}
	Sum[bu] = sum; Prod[bu] = prod;
}

long long T[10];

inline bool zero(long long a)
{
	while(a){ if(a % 10 == 0)	return 1; a/=10; }
	return 0;
}

bool luckyFaster(long long a)					// at least I think so...
{
	long long sum = Sum[a % 100000] + Sum[ (a/T[1])%100000 ] + Sum[ (a/T[2])%100000 ]
				  + Sum[ (a/T[3])%100000 ];
	long long prod = Prod[a % 100000] * Prod[ (a/T[1])%100000 ] * Prod[ (a/T[2])%100000 ]
				  * Prod[ (a/T[3])%100000 ];
//	if(4000000-a < 30)std :: cout << a << " " << sum << " " << prod << "\n";
	return (prod % sum == 0);
}

long long a,b, res;
int main()
{
	std :: cin >> a >> b;
	T[0] = 1;
	ff(i, 1, 4) T[i] = 100000 * T[i - 1];
//	f(i, 4) std :: cout << T[i] << "\n";
	for(int i = 0 ; i < 100025; i ++)	init(i);
//	f(i, 25) printf("%d %d %d\n", i, Sum[i], Prod[i]);
//	std :: cout << Sum[227] << " " << Prod[227] << "\n";
//	std :: cout << Sum[834] << " " << Prod[834] << "\n";
	if( b - a < 6000000 )
	{
		for(register long long i = a; i <= b; i ++)
			if( zero(i) || luckyFaster(i))
//			if( lucky(i) )
			{
				res ++;
//				std :: cout << i << "\n";
			}
		std :: cout << res << "\n";
		return 0;
	}
    return 0;
}
