#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
using namespace std;

long long A[1024*128];
int N;

long long calcmed(int k)
{
	long long A2[1024*128];
	int cnt = 0;
	for (int i = 1; i <= N; i++) if (i != k)
	 A2[cnt++] = abs(A[i] - A[k]);
	sort(A2, A2 + cnt);
	return A2[N/2-1];
}

int main()
{
	cin >> N;
	A[0]  = -10000000000LL;
	A[N+1] = 10000000000LL;
	for (int i = 1; i <= N; i++)
	 cin >> A[i];
	sort(A, A + N + 2);
	
	int l = 0, r = N + 1;
	while (l + 1 != r)
	{
		int m = (l + r)/2;
		long long ans1 = calcmed(m);
		long long ans2 = calcmed(m + 1);
		
		if (ans1 == ans2)
		{
			long long ans = ans1;
			
			int l1 = l, r1 = m;
			while (l1 + 1 != r1)
			{
				int m1 = (l1 + r1)/2;
				if (ans1 == calcmed(m1)) r1 = m1;
				else l1 = m1;
			}
			ans1 = calcmed(l1);
			
			int l2 = m, r2 = r;
			while (l2 + 1 != r2)
			{
				int m2 = (l2 + r2)/2;
				if (ans2 == calcmed(m2)) l2 = m2;
				else r2 = m2;
			}
			ans2 = calcmed(r2);
			
	     	if (ans > ans2) l = m;
			else r = m;
		}
		else if (ans1 > ans2) l = m;
		     else r = m;
	}
	
	long long ansl = calcmed(l);
	long long ansr = calcmed(r);
	
	//cout << ansl << " " << ansr << endl;
	if (ansl <= ansr) cout << A[l] << endl;
	else cout << A[r] << endl;
	return 0;
}
