# include <stdio.h>
# include <stdlib.h>
# define MAXN (1<<20)

int n,l,r;
int data[MAXN];
int raz[MAXN];	
int m,minm;

int cmp(const void *e1,const void *e2) {
	return *(int*)e1 - *(int*)e2;	
}

void read() {
	scanf("%d", &n);
	for(int i = 0; i < n; i++) {
		scanf("%d", &data[i]);	
	}
	qsort(data,n,sizeof(int),cmp);		
}

int calc(int p) {
	int cnt = 0;
	for(int i = 0; i < n; i++) {
		if(i!= p) {
			raz[cnt++] = abs(data[i]-data[p]);	
		}	
	}
	qsort(raz,cnt,sizeof(int),cmp);
	return raz[cnt/2];	
	
}

int main() {
	read();		
	l = 0;
	r = n;
	minm = -1;
	while(r-l > 2) {
		int t,t1,t2;
		//printf("l = %d  r = %d\n", l,r);
		int mid = (l+r)/2;	
		t = calc(mid);
		//printf("t = %d\n", t);
		if(minm == -1 || minm > t) {
			minm = t;
			m = mid;	
		}
		t1 = calc(mid-1);
		t2 = calc(mid+1);
		//printf("t1 = %d  t2 = %d\n\n", t1,t2);
		if(t1 < t2) r = mid;
		else l = mid+1;
	}
	for(int i = l; i <= r; i++) {
		int t;
		t = calc(i);
		if(minm == -1 || minm >= t) {
			minm = t;
			m = i;	
		}	
	}	
	printf("%d\n", data[m]);	
	return 0;
}
