#include <iostream>
#include <cstdio>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 17;
const int INF = 1000000001;

int i, j, n, k, px;
int a[MAXN], b[MAXN];
int l, r, x, y, med;

struct A {
    int a, med; // chislo, mediana
    bool operator < (A o) const {
        if (med < o.med) return 1;
        else if (med == o.med && a > o.a) return 1;
        return 0;
    }
    A () {}
    A (int _a, int _med): a (_a), med (_med) {}
} ans[MAXN];

inline int aa (int p) {
    return abs (a[i] - a[p]);
}

void calc () {
    int tmp = n - k + 1;
    if (px >= tmp) tmp--;
    x = 1; y = tmp;
    // [l, r]
    //printf ("%d %d %d\n", k, x, y);
    while (x <= y) {
        med = (x + y) / 2;
        //-- init
        l = med;
        r = med + k - 1;
        if (px > l && px <= r) r++;
        else if (px == l) l--;//r--
        
        //else if (px <= r) r++;
        //--
        //printf ("x = %d y = %d, l = %d, r = %d\n", x, y, l, r);
        if (l-1!=px && aa (l-1) < aa (r)) { // shift left
            y = med - 1;
        }
        else if (l-1==px && aa(l-2)<aa(r)) y = med - 1;
        
        else if (r+1!=px && aa (r+1) < aa (l)) { // shift right
            x = med + 1;
        }
        else if (r+1==px && aa (r+2) < aa (l)) x = med + 1;
        else {
            //printf ("found\n");
            break;
        }
    }
    //
    l = med;
    r = med + k - 1;
    if (px > l && px <= r) r++;
    else if (px == l) l--;//r--
    
    int mm = max (aa (l), aa (r));
    ans [i] = A (a[i], mm);
    //sort (ans + 1, ans + n + 1);
    //printf ("chislo: %d, med: %d\n", ans[i].a, ans[i].med);
}

void solve () {
    k = n / 2;
    sort (a + 1, a + n + 1);
    a[0] = INF;
    a[n+1] = INF;
    for (i = 1; i <= n; i++) {
        px = i;
        calc ();
        //printf ("%d ", a[i]);
    }
    sort (ans + 1, ans + n + 1);
    printf ("%d\n", ans[1].a);
}

void brute () {
    k = n/2;
    for (i = 1; i <= n; i++) {
        for (j = 1; j <= n; j++) {
            if (j != i) b[j] = abs (a[i] - a[j]);
        }
        b[i] = INF;
        sort (b + 1, b + n + 1);
        ans[i] = A (a[i], b[k]);
        //printf ("%d: %d %d\n", i, a[i], b[k]);
    }
    sort (ans + 1, ans + n + 1);
    printf ("%d\n", ans[1].a);
}

int main () {
    //freopen ("med.inp", "rt", stdin);
    //freopen ("med.out", "wt", stdout);
    scanf ("%d", &n);
    for (i = 1; i <= n; i++) scanf ("%d", &a[i]);
    if (n > 5000) solve ();
    else brute ();
    //system ("pause");
    return 0;
}
