#include <iostream>
using namespace std;

const int MN = 514;
const int INF = 1000000001;

int i, j, n, N, K, source, sink;
int a[MN][MN];
int d[MN];
int prev[MN], cp;
int lev[MN];
bool u[MN];
int MaxFlow, sum, sum2;
int cap[MN], o[MN], br;

int rec (int v) {
    //printf ("[%d] ", v);
    if (v == source) return INF;
    if (u[v]) return cap[v];
    int ans = 0, ii;
    for (ii = 1; ii <= n; ii++)
        if (a[v][ii] && lev[ii] > lev[v]) {
            //ans = max (ans, min (a[v][ii], rec (ii)));
            if (ans < min (a[v][ii], rec (ii))) {
                ans = min (a[v][ii], rec (ii));
                prev[v] = ii;
            }
        }
    u[v] = 1;
    cap[v] = ans;
    return ans;
}

void solve () {
    source = n + 2;
    sink = n + 1;
    lev[sink] = 0;
    lev[source] = 3;
    n += 2;

    int t1, t2;
    while (1) {
        //for (i = 1; i <= n; i++){
        //for (j = 1; j <= n; j++)
        //    printf ("%11d ", a[i][j]); printf ("\n");}
            
        //printf ("start\n");
        rec (sink);
        br = 0;
        if (cap[sink] == 0 || cap[sink] == INF) break;
        MaxFlow += cap[sink];
        
        i = sink;
        while (prev[i] != 0) o[++br] = i, i = prev[i];
        o[++br] = source;
        for (i = 1; i < br; i++) {
            t1 = o[i]; t2 = o[i+1];
            a[t1][t2] -= cap[sink];
            a[t2][t1] -= cap[sink];
        }
        //for (i = 1; i <= br; i++) printf ("%d ", o[i]);
        //printf ("\n");
        memset (u, 0, sizeof (u));
        memset (cap, 0, sizeof (cap));
    }
    if (MaxFlow == sum) printf ("Yes\n");
    else printf ("No\n");
}

int main () {
    //freopen ("ks.inp", "rt", stdin);
    //freopen ("ks.out", "wt", stdout);
    scanf ("%d %d", &N, &K);
    n = N + K;
    int t, c, q;
    for (i = 1; i <= N; i++) {
        scanf ("%d", &c);
        sum += c;
        a[i][n+1] = c;
        a[n+1][i] = c; //
        lev[i] = 1;// <--------
    }
    for (i = 1; i <= K; i++) {
        scanf ("%d %d", &q, &t);
        sum2 += q;
        a[n+2][N+i] = q;
        a[N+i][n+2] = q; //
        lev[N+i] = 2;// <-------
        for (j = 1; j <= t; j++) {
            scanf ("%d", &q);
            a[N+i][q] = INF;
            a[q][N+i] = INF; //
        }
    }
    if (sum != sum2) {printf ("No\n"); return 0;}
    solve ();
    //system ("pause");
    return 0;
}
