#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>

using namespace std;

#define MAXN 64
#define MAXK 512

#define DOWN 0
#define LEFT 1
#define RIGHT 2

#define DEBUGg

typedef struct {
    int v[3][3];
}cell;

cell dp[2][MAXN][MAXK];
int row[MAXN];
int pos[MAXN];
int flag = 0;
int N, K, T, P;

bool zab[3][3][3];

int main() {
    
    scanf("%d%d%d%d", &N, &K, &T, &P);
    
    int i, j, k;
    int currentCount;
    int f, s, n ;
    
    
    for (i = 0; i < P; i++) {
        scanf("%d", &j);
        zab[j/100][(j%100)/10][j%10] = true;
    }
    
#ifdef DEBUG
    for (f = 0; f < 3; f++) {
        for (s = 0; s < 3; s++) {
            printf("( ");
            for (n = 0; n < 3; n++) {
                printf("%d ", zab[f][s][n]?1:0);
            }
            printf(" )");
        }
        printf("\n");
    }
#endif
    
    for (i = 0; i < T; i++) {
        scanf("%d", &currentCount);
        for (j = 0; j < currentCount; j++) {
            scanf("%d", &pos[j]);
            scanf("%d", &row[pos[j]]);
        }
        
        for (j = 1; j <= N; j++) {
            for (k = 0; k <= K; k++) {
                
                for (f = 0; f < 3; f++) { //MEMSET OF OLD ROW
                    for (s = 0; s < 3; s++) {
                        dp[flag][j][k].v[f][s] = 0;
                    }
                }
                
                for (f = 0; f < 3; f++) { 
                    for (s = 0; s < 3; s++) {
                        
                        //FROM ABOVE
                        if (!zab[f][s][DOWN] && dp[flag][j][k].v[s][DOWN] < dp[!flag][j][k].v[f][s] + row[j]) {
                             dp[flag][j][k].v[s][DOWN] = dp[!flag][j][k].v[f][s] + row[j];
                        }

                        if (!k) {
                            continue;
                        }
                        
                        //FROM LEFT
                        if ((j > 1) && (!zab[f][s][RIGHT]) && (dp[!flag][j-1][k-1].v[f][s] + row[j] > dp[flag][j][k].v[s][RIGHT])) {
                            dp[flag][j][k].v[s][RIGHT] = dp[!flag][j-1][k-1].v[f][s] + row[j];
                            if (j == 1) {
                                exit(22);
                            }
                        }
                        //FROM RIGHT
                        if ((j < N) && (!zab[f][s][LEFT]) && (dp[!flag][j+1][k-1].v[f][s] + row[j] > dp[flag][j][k].v[s][LEFT])) {
                            dp[flag][j][k].v[s][LEFT] = dp[!flag][j+1][k-1].v[f][s] + row[j];
                        }
                    }

                }
            } //k cycle
        }//j cycle
        for (j = 0; j < currentCount; j++) {
            row[pos[j]] = 0;
        }
        
#ifdef DEBUG
        for (int j = 1; j <= N; j++) {
            for (int k = 0; k <= K; k++) {
                printf("(pos:%d moves:%d)\n", j, k);
                
                for (f = 0; f < 3; f++) {
                    for ( s = 0; s < 3; s++) {
                        printf("%d ", dp[flag][j][k].v[f][s]);
                    }
                    printf("\n");
                }
                printf("\n");
            }
        }
        printf("========================\n");
#endif
        
        flag = !flag;
    }
    
    flag = !flag;
    
    int maxValue = 0;
    for (int j = 1; j <= N; j++) {
        for (int k = 0; k <= K; k++) {
            for (f = 0; f < 3; f++) {
                for (s = 0; s < 3; s++) {
                    if (dp[flag][j][k].v[f][s] > maxValue) {
                        maxValue = dp[flag][j][k].v[f][s];
                    }
                }
            }
        }
    }
    
    printf("%d\n", maxValue);
    
    return 0;
}
