/*
TASK: trudna
NAME: Petar Ivanov
*/

#include <cstdio>
#include <algorithm>
using namespace std;

#define max(a,b) ((a)>(b))?(a):(b)

const int MAX_P     = 8;
const int MAX_T     = 512;
const int MAX_N     = 64;
const int MAX_K     = 512;
const int MAX_MOVES = 9;

int N, K, T, P;
int forbid[MAX_P];
bool poss[MAX_MOVES][3];

int A[MAX_T][MAX_N];

int dp[2][MAX_MOVES][MAX_N+2][MAX_K+2];  // 2 !!!!!!!!!!!! Memory Limit
int ans=0;

void input ()
{
	int i, j, r, pos, val, moves, move;

	scanf ("%d%d%d%d", &N, &K, &T, &P);

	for (i=0; i<P; i++)
		scanf ("%d", &forbid[i]);

	for (moves=0; moves<MAX_MOVES; moves++)
		for (move=0; move<3; move++) {
			poss[moves][move] = 1;
			
			for (i=0; i<P; i++)
				if (forbid[i]==100*(moves/3)+10*(moves%3)+move)
					poss[moves][move] = 0;
		}

	for (i=1; i<=T; i++) {
		scanf ("%d", &r);
		
		for (j=0; j<r; j++) {
			scanf ("%d%d", &pos, &val);
			A[i][pos] = val;
		}
	}
}

// forward seeking
void solve ()
{
	int t, n, k, moves, move, next_moves;

	memset (dp,1<<7,sizeof(dp));

	for (moves=0; moves<MAX_MOVES; moves++)
		for (n=0; n<=N; n++)
			dp[0][moves][n][0] = 0;

	for (t=0; t<T; t++) {
		for (moves=0; moves<MAX_MOVES; moves++)
			for (move=0; move<3; move++)
				if (poss[moves][move]) {
					next_moves = moves%3+move;

					for (n=1; n<=N; n++) {
						for (k=0; k<=K; k++) {
							dp[!(t&1)][next_moves][n-1][k+1] = max(dp[!(t&1)][next_moves][n-1][k+1], dp[t&1][moves][n][k] + A[t+1][n-1]);
							dp[!(t&1)][next_moves][ n ][ k ] = max(dp[!(t&1)][next_moves][ n ][ k ], dp[t&1][moves][n][k] + A[t+1][ n ]);
							dp[!(t&1)][next_moves][n+1][k+1] = max(dp[!(t&1)][next_moves][n+1][k+1], dp[t&1][moves][n][k] + A[t+1][n+1]);
						}
					}
				}

		memset (dp[t&1],1<<7,sizeof(dp[t&1]));
	}

	for (moves=0; moves<MAX_MOVES; moves++)
		for (n=1; n<=N; n++)
			for (k=0; k<=K; k++)
				ans = max(ans,dp[T&1][moves][n][k]);
}

int main ()
{
	//freopen ("trudna.in", "r", stdin);

	input ();
	solve ();

	printf ("%d\n", ans);

	return 0;
}