#include <iostream>
using namespace std;

const int MAXN = 1 << 19;
const int MAXX = 1 << 20;

struct P {
    int v, d;
    P () {}
    P (int _v, int _d): v (_v), d (_d){}
};
struct edge {
    int s, e, d;
    edge () {}
    edge (int _s, int _e, int _d): s (_s), e (_e), d (_d) {}
    bool operator < (edge o) const {
        if (s < o.s) return 1;
        if (s == o.s && e < o.e) return 1;
        return 0;
    }
} b[MAXN];

int i, j, n, m, k;
int r[20][MAXX];
int q[MAXN], br, d[MAXN], num[MAXN], pos[MAXN], fstp[3*MAXN], rev[MAXN], g[100], val[100];
bool u[MAXN], is[100];
int cans, s, st, pp, tmp, tmp2, diff, b2[23];
int beg[MAXN], e[MAXN], *x;

void bfs () {
    rev[1] = 1;
    q[++br] = 1;
    u[1] = 1;
    num[1] = 1;
    int temp = 1, nv, nd;
    while (temp <= br) {
        if (beg[q[temp]] != 0)
        for (i = beg[q[temp]]; i <= e[q[temp]]; i++) {
            nv = b[i].e;
            nd = b[i].d;
            if (!u[nv]){
                q[++br] = nv;
                u[nv] = 1;
                d[nv] = d[q[temp]] + nd;
                num[nv] = br;
                rev[br] = nv;
            }
        }
        temp++;
    }
/*    for (i = 1; i <= n; i++) printf ("%d ", q[i]);
    printf ("\n");
    for (i = 1; i <= n; i++) printf ("%d ", num[i]);
    printf ("\n");*/
}

void dfs (int v) {
    //printf ("->%d\n", v);
    int ii;
    if (beg[v] != 0)
    for (ii = beg[v]; ii <= e[v]; ii++) {
        dfs (b[ii].e);
        if (ii < e[v]) {
            r[0][++br] = num[v];
            if (!fstp[v]) fstp[v] = br;
        }
    }
    r[0][++br] = num[v];
    if (!fstp[v]) fstp[v] = br;
}

void pre_calc () {
    st = 1;
    pp = 0;
    while (st < s) st *= 2, pp++;
    //printf ("%d %d\n", st, pp);
    for (i = 1; i <= pp; i++) {
        tmp = s - (1 << i) + 1;
        tmp2 = 1 << (i-1);
        for (j = 1; j <= tmp; j++) {
            r[i][j] = min (r[i-1][j], r[i-1][j+tmp2]);
        }
    }
    //for (i = 0; i <= pp; i++) {
    //    for (j = 1; j <= s; j++) printf ("%3d", r[i][j]); printf ("\n");}
}

inline int query (int &p1, int &p2) {
    diff = p2 - p1 + 1;
    pp = 0; st = 1;

    if (diff > b2[6]) {
        x = lower_bound (b2 + 1, b2 + 21, diff);
        if (*x > diff) {pp = (x - b2) - 1; st = *(x - 1);}
        else pp = (x - b2), st = *(x);
    }
    else {
        while (st <= diff) pp++, st *= 2;
        st /= 2; pp--;
    }
    //printf ("->%d %d, min(r[%d][%d],r[%d][%d])<-\n", st, pp, pp,p1,pp,p2-st+1);
    cans = min (r[pp][p1], r[pp][p2-st+1]);
    return cans;
}

void solve () {
    bfs ();
    br = 0;
    dfs (1);
    /*for (i = 1; i <= br; i++) printf ("%d ", r[0][i]);
    printf ("\n");
    for (i = 1; i <= n; i++) printf ("%d ", fstp[i]);
    printf ("\n");*/
    //---
    s = br;
    pre_calc ();
    //printf ("-----\n");
    int v1, v2, nv1, nv2, ans, p1, p2, com; // obsht
/*    v1 = 7; v2 = 6;
    p1 = fstp[v1];
    p2 = fstp[v2];
    nv1 = num[v1];
    nv2 = num[v2];
    if (p1 > p2) swap (p1, p2);
    ans = query (p1, p2);
    if (ans == nv1 || ans == nv2) { // ediniqt e obsht
        com = rev[ans];
        printf ("common: %d\n", com);
    }
    else {
        com = rev[ans];
        printf ("common: %d\n", com);
    }*/
    int t, l, answer, curcut;
    for (l = 1; l <= k; l++) {
        //printf ("*******\n");
        answer = 0;
        scanf ("%d", &t);
        for (i = 1; i <= t; i++) scanf ("%d", &g[i]);
        
        for (i = 1; i < t; i++)
            for (j = i + 1; j <= t; j++) {
                v1 = g[i]; v2 = g[j];
                p1 = fstp[v1]; p2 = fstp[v2];
                nv1 = num[v1]; nv2 = num[v2];
                if (p1 > p2) swap (p1, p2);
                ans = query (p1, p2);
                com = rev[ans];
                
                //printf ("between %d, %d (query = %d): %d\n", g[i], g[j], ans, com);
                if (ans != 1 && val[i] < ans) {val[i] = ans; is[i] = 1;}
                if (ans != 1 && val[j] < ans) {val[j] = ans; is[j] = 1;}
            }
        
        for (i = 1; i <= t; i++) {
            //printf ("{%d, %d}", val[i], g[i]);
            curcut = rev[val[i]];
            if (is[i]) {
                //printf ("<%d - (%d/2)>", d[g[i]], d[curcut]);
                answer += d[g[i]] - (d[curcut]/2);
            }
            else {answer += d[g[i]];}//printf ("<%d>", d[g[i]]);}
            val[i] = 0;
            is[i] = 0;
        }
        printf ("%d\n", answer);
    }
}

int main () {
    //freopen ("lesna.inp", "rt", stdin);
    //freopen ("lesna.out", "wt", stdout);
    scanf ("%d %d %d", &n, &m, &k);
    for (i = 1, b2[0] = 1; i <= 21; i++) b2[i] = b2[i-1] * 2;
    int t1, t2, t3;
    for (i = 1; i <= m; i++) {
        scanf ("%d %d %d", &t1, &t2, &t3);
        b[i] = edge (t1, t2, t3);
    }
    sort (b + 1, b + m + 1);
    for (i = 1; i <= m; i++) {
        //printf ("%d %d %d\n", b[i].s, b[i].e, b[i].d);
        if (b[i].s != b[i-1].s) beg[b[i].s] = i;
        e[b[i].s] = i;
    }
    //for (i = 1; i <= n; i++) printf ("beg = %d e = %d\n", beg[i], e[i]);
    solve ();
    //system ("pause");
    return 0;
}
