#include <algorithm>
#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

int N, Q, x, y;
vector<int> d, v, pd;
vector<double> t;

double cas(int x, int y) {
  double res = 0;
  for (int i=0; i<N; ++i) {
    if (pd[i] >= y) continue;
    if (pd[i+1] <= x) continue;
    double l = min(y,pd[i+1]) - max(x,pd[i]);
    res += l / v[i];
  }
  return res;
}

int main() {
  scanf("%d",&N);
  d.resize(N); v.resize(N);
  for (int n=0; n<N; ++n) scanf("%d",&d[n]);
  for (int n=0; n<N; ++n) scanf("%d",&v[n]);
  t.resize(N+1);
  t[0] = 0;
  for (int n=0; n<N; ++n) t[n+1] = t[n] + ( 1. * d[n] / v[n] );
  pd.resize(N+1);
  pd[0] = 0;
  for (int n=0; n<N; ++n) pd[n+1] = pd[n] + d[n];
  scanf("%d",&Q);
  while (Q--) {
    scanf("%d%d",&x,&y);
    printf("%.10f\n",cas(x,y));
  }
}
