#include <algorithm>
#include <cstdio>
using namespace std;

int R, S;
int A[3012][3012], B[3012][3012], C[3012][3012];

int verify(int r, int s, int d) {
  return (B[r-d][s+1] - B[r-d][s-d] == d+1) && (C[r+1][s-d] - C[r-d][s-d] == d+1);
}

int main() {
  scanf("%d %d ",&R,&S);
  for (int r=0; r<R; ++r) for (int s=0; s<S; ++s) scanf("%d",&A[r][s]);
  for (int r=0; r<R; ++r) {
    B[r][0] = 0;
    for (int s=0; s<S; s++) B[r][s+1]=B[r][s]+A[r][s];
  }
  for (int s=0; s<S; s++) {
    C[0][s] = 0;
    for (int r=0; r<R; ++r) C[r+1][s]=C[r][s]+A[r][s];
  }
  long long result = 0;
  for (int r=0; r<R; ++r)
    for (int s=0; s<S; ++s)
      for (int d=0; d<=min(r,s); ++d) { if (!verify(r,s,d)) break; ++result; }
  printf("%Ld\n",result);
  return 0;
}
