#include <algorithm>
#include <numeric>
#include <cstdio>
#include <vector>
#include <string>
using namespace std;

class sutaziaci { public: string meno; int body; };

bool operator< (const sutaziaci &A, const sutaziaci &B) {
  if (A.body != B.body) return A.body > B.body;
  return A.meno < B.meno;
}

int main() {
  int S, R;
  scanf("%d%d",&S,&R);
  vector<sutaziaci> vysledky(S);
  for (int s=0; s<S; ++s) {
    char buf[12];
    scanf("%s",buf);
    vysledky[s].meno = buf;
    vector<int> znamky(6001,0);
    for (int r=0; r<R; ++r) { int x; scanf("%d",&x); ++znamky[x]; }
    int lo=0; while (!znamky[lo]) ++lo; --znamky[lo];
    int hi=6000; while (!znamky[hi]) --hi; --znamky[hi];
    vysledky[s].body = 0;
    for (int i=1; i<=6000; ++i) vysledky[s].body += i*znamky[i];
  }
  sort( vysledky.begin(), vysledky.end() );
  for (int s=0; s<S; ++s) printf("%d: %s\n",vysledky[s].body,vysledky[s].meno.c_str());
}

