#include <algorithm>
#include <numeric>
#include <iostream>
#include <vector>
#include <string>
using namespace std;

struct sutaziaci { string meno; int body; };

bool operator< (const sutaziaci &A, const sutaziaci &B) {
  if (A.body != B.body) return A.body > B.body; else return A.meno < B.meno;
}

int S, R, lo, hi, cur;

int main() {
  cin >> S >> R;
  vector<sutaziaci> vysledky(S);
  for (int s=0; s<S; ++s) {
    vysledky[s].body = 0;
    cin >> vysledky[s].meno >> lo >> hi; 
    if (lo > hi) swap(lo,hi);
    for (int r=0; r<R-2; ++r) {
      cin >> cur; 
      if (cur < lo) swap(lo,cur); 
      if (cur > hi) swap(hi,cur); 
      vysledky[s].body += cur;
    }
  }
  sort( vysledky.begin(), vysledky.end() );
  for (int s=0; s<S; ++s) cout << vysledky[s].body << ": " << vysledky[s].meno << endl;
}

