#include <algorithm>
#include <numeric>
#include <iostream>
#include <vector>
#include <string>
using namespace std;

class sutaziaci { public: string meno; int body; };

bool operator< (const sutaziaci &A, const sutaziaci &B) {
  if (A.body != B.body) return A.body > B.body;
  return A.meno < B.meno;
}

int main() {
  int S, R;
  cin >> S >> R;
  vector<sutaziaci> vysledky(S);
  for (int s=0; s<S; ++s) {
    cin >> vysledky[s].meno;
    vector<int> znamky(R);
    for (int r=0; r<R; ++r) cin >> znamky[r];
    vysledky[s].body 
      = accumulate( znamky.begin(), znamky.end(), 0 )
      - *max_element( znamky.begin(), znamky.end() )
      - *min_element( znamky.begin(), znamky.end() );
  }
  sort( vysledky.begin(), vysledky.end() );
  for (int s=0; s<S; ++s) cout << vysledky[s].body << ": " << vysledky[s].meno << endl;
}

