#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
using namespace std;

struct poziadavka { int zac, kon, farba; };
vector<poziadavka> P;
int N, F, K;

// nacitanie vstupu
void load() {
  cin >> N >> F >> K;
  poziadavka tmp;
  for (int i=0; i<N; ++i) { 
    cin >> tmp.zac >> tmp.kon >> tmp.farba;
    P.push_back(tmp);
  }
}

int main() {
  load();

  vector<int> bounds;
  bounds.push_back(0);
  bounds.push_back(K);
  for (int i=0; i<N; ++i) bounds.push_back(P[i].zac);
  for (int i=0; i<N; ++i) bounds.push_back(P[i].kon);
  sort( bounds.begin(), bounds.end() );
  vector<int>::iterator new_end = unique( bounds.begin(), bounds.end() );
  bounds.resize( new_end - bounds.begin() );
  int Z = bounds.size() - 1;
  
  vector<int> current(Z,0);
  for (int i=0; i<N; ++i)
    for (int z=0; z<Z; ++z)
      if (P[i].zac <= bounds[z] && bounds[z+1] <= P[i].kon)
        current[z] = P[i].farba;

  vector<int> farby(F+1,0);
  for (int z=0; z<Z; ++z) farby[ current[z] ] += bounds[z+1] - bounds[z];
  for (int f=1; f<=F; f++) cout << farby[f] << endl;
}

