#include <stdio.h>
#include <stdlib.h>
#define MAXV 5001
#define INFILE "bile7.in"
#define OUTFILE "bile7.out"

typedef struct lista
{
	int v;
    struct lista* next;
}link;


int v, poz, broj_auta;
link* graf[MAXV];
int bio[MAXV], car[MAXV];
int staza[MAXV];

int smetnja[MAXV];
int broj;

int queue[MAXV];
int top, down;
int suma = 0, sol;
FILE *fin, *fout;
int nema = 0;

int sol;


void ispis( void )
{
	fout = fopen( OUTFILE, "wt" );
    if( !nema ) fprintf( fout, "%d\n", sol ); else fprintf( fout, "-1\n" );
    fclose( fout );
}
void init_queue( void )
{
	top = down = 0;
}
int get( void )
{
	return queue[down++];
}
void put( int i )
{
	queue[top++] = i;
}

void sredi( int x )
{
    int i;
    link* l;

    init_queue();
    for( i = 1; i <= v; i++ ) bio[i] = 0;
    put( x );
    bio[x] = 1;
    bio[poz] = -1;
    nema  = 1;

    while(  top != down )
    {
    	i = get();
        if( !car[i]  && !staza[i] )
        {
        	sol = sol + bio[i] - 1;
            car[i] = 1;
            car[x] = 0;
            nema = 0;
            break;
        }
        l = graf[i];
        while( l != NULL )
        {
            if( !bio[l -> v ] )
            {
              put( l -> v );
              bio[ l ->v ] = bio[i] + 1;;
            }
            l = l -> next;
        }
    }

}
int main( void )
{
    int i, x, z, j;
    link* l;

 	fin = fopen( INFILE, "rt" );
 	fscanf( fin, "%d %d %d", &v, &poz, &broj_auta );
    for( i = 1; i <= v; i++ ) graf[i] = NULL;
    for( i = 1; i <= v ; i++ )
    {
    	fscanf( fin, "%d", &z );
        for( j = 1; j <= z; j++ )
        {
    		fscanf( fin, "%d", &x );
        	l = (link * ) malloc( sizeof( link ) );
        	l -> v = x;
        	l -> next = graf[i];
        	graf[i] = l;
        }
    }
    for( i = 1; i <= broj_auta; i++ )
    {
   		 fscanf( fin, "%d", &x );
         car[x] = 1;
    }
 	fclose( fin );

    init_queue();
    for( i = 1; i <= v; i++ ) bio[i] = 0;
    put( 1 );
    bio[1] = 1;

    while( !bio[poz] )
    {
    	i = get();
        l = graf[i];
        while( l != NULL )
        {
            if( !bio[l -> v ] )
            {
              put( l -> v );
              bio[ l ->v ] = i;
            }
            l = l -> next;
        }
    }

    car[poz] = 1;
    i = poz;
    broj = 0;
    staza[poz] = 1;
    while( bio[i] != 1  )
    {
    	i = bio[i];
        staza[i] = 1;
        if( car[i] ) smetnja[++broj] = i;
    }

    for( i = 1; i <= broj; i++ )
    {
    	sredi( smetnja[i] );
        if( nema ) break;
    }

  	ispis();
 	return 0;
}
