#include <stdio.h>

#define NMAX 100100
#define INF 100000000000000000LL

long long w[NMAX], sp[NMAX], cmin[2][NMAX], ydq[NMAX], sldq[NMAX], pozfirst[NMAX], y, sl, ykdq, dy, dx, xcross, pozf;
int l[NMAX], u[NMAX], pozdq[NMAX];
int i, j, k, N, K, a, c, lastu, li, ls;

int main()
{
	freopen("costsq.in", "r", stdin);
	scanf("%d %d", &N, &K);
	for (i = 1; i <= N; i++)
		scanf("%lld %d %d", &w[i], &l[i], &u[i]);

	sp[0] = 0;
	for (i = 1; i <= N; i++)
		sp[i] = sp[i - 1] + w[i];

	cmin[0][0] = 0;
	for (i = 1; i <= N; i++)
		cmin[0][i] = INF;
	c = 0;

	for (k = 1; k <= K; k++)
	{
		a = c;
		c = (c + 1) % 2;
		for (i = 0; i < k; i++)
			cmin[c][i] = INF;

		lastu = -1;
		li = 0;
		ls = -1;
		for (i = k; i <= N; i++)
		{
			// add new candidates
			while (lastu + 1 < u[i])
			{
				lastu++;
				// consider the position lastu as the previous ending endpoint

				y = cmin[a][lastu] - sp[lastu] * sp[lastu];
				sl = -2 * sp[lastu];
				pozf = lastu;

				while (li <= ls)
				{
					ykdq = ydq[ls] + sldq[ls] * (sp[lastu] - sp[pozdq[ls]]);
					if (y < ykdq)
						ls--;
					else
					{
						dy = y - ykdq;
						dx = dy / (sldq[ls] - sl);

						if (y + dx * sl >= ykdq + dx * sldq[ls])
							dx++;

						xcross = sp[lastu] + dx;
						if (xcross <= pozfirst[ls])
							ls--;
						else
						{
							pozf = xcross;
							break;
						}
					}
				}

				ls++;
				ydq[ls] = y;
				sldq[ls] = sl;
				pozdq[ls] = lastu;
				pozfirst[ls] = pozf;
			}

			// cleanup the front of the deque
			while (li <= ls && pozdq[li] < l[i] - 1)
				li++;

			while (li < ls && pozfirst[li + 1] <= sp[i])
				li++;

			if (i == N)
			{
				j = j;
			}

			if (li > ls)
				cmin[c][i] = INF;
			else
				cmin[c][i] = sp[i] * sp[i] + ydq[li] + sldq[li] * (sp[i] - sp[pozdq[li]]);
		}
	}
	
	freopen("costsq.out", "w", stdout);
	printf("%lld\n", cmin[c][N]);

	return 0;
}
