/*
TASK:E
LANG:C++
*/
#include <iostream>

using namespace std;

const int MAXN = 256;
const int MAXB = 2048;

int n, b;
long F[ MAXN ][ MAXB ];
int best[ MAXN ][ MAXB ];

int main( )
{
	int i, j, x;
	cin >> n >> b;
	for ( i=0; i<=n; i++ )
	{
		F[ i ][ 0 ] = 0;		
		best[ i ][ 0 ] = 0;
	}
	for ( j=0; j<=b; j++ )
	{
		F[ 0 ][ j ] = 0;
		best[ 0 ][ j ] = j;
	}

	for ( i=1; i<=n; i++ )
		for ( j=1; j<=b; j++ )
		{	F[ i ][ j ] = 0;
			for ( x=1; x<=best[ i-1 ][ j ]; x++ )
				if ( F[ i-1 ][ j-x ] + ( (j-x)*x ) > F[ i ][ j ] )
				{	F[ i ][ j ] = F[ i-1 ][ j-x ] + (j-x)*x;
					best[ i ][ j ] = x;
				}
		}
	cout << F[ n ][ b ] << endl;
	return 0;
}