/*
TASK:d
LANG:C++
*/

#include <cstdio>
#include <vector>

#include <ctime>

int main()
{
	unsigned int s;
	unsigned int answer = 0;
	std::scanf("%u", &s);
	std::clock();
	std::vector<bool> is_bsqr(s+1, false);
	std::vector<unsigned int> sqr(1, 0);
	for (unsigned int i = 1; i*i <= s; i++)
		sqr.push_back(i*i);

	for (unsigned int i = 0; i < sqr.size(); i++)
		for (unsigned int j = i; j < sqr.size() && (sqr[i] + sqr[j] <= s); j++)
			if (!is_bsqr[sqr[i] + sqr[j]])
			{
				is_bsqr[sqr[i] + sqr[j]] = true;
				answer++;
			}

	answer--;

	std::printf("%u\n", answer);
	//std::printf("%.2lf\n", std::clock()/(double)CLOCKS_PER_SEC);

	return 0;
}
