// S. Kapralov

#include <iostream>
using namespace std;

class Point
{ public:
    int x,y;
    Point(int x0, int y0){x=x0; y=y0; }
};
 
class Vector
{ public:
    int a,b;
    Vector(Point A, Point B)
  	{ a = B.x - A.x;
	    b = B.y - A.y;
	  }
};

int direction(Vector v1, Vector v2)
{ int p1 = v1.a*v2.b;
  int p2 = v1.b*v2.a;
  if(p1>p2) return 1;
  if(p1<p2) return -1;
  return 0;
}

int main()
{  int x, y;
   cin >> x >> y;  Point A(x,y);
   cin >> x >> y;  Point B(x,y);
   cin >> x >> y;  Point C(x,y);
   int n;  cin>>n;

   Vector AB(A,B), AC(A,C), BC(B,C);
   int dir = direction(AB,AC);
  
	 int cnt = 0;
	 for (int i=1; i<=n; i++)
	 { cin >> x >> y;  Point M(x,y);
     Vector AM(A,M), BM(B,M), CM(C,M);

     if( dir * direction(AB,AM) >= 0
      && dir * direction(AC,AM) <= 0
      && dir * direction(BC,BM) >= 0
       ) cnt++;
	 }

  	cout << cnt << endl;
	return 0;
}
