#include <iostream>
#include <algorithm>
using namespace std;

class Point
{ public:
    long x;
    char label;
    
    Point(long x1=0, char lab='?')
    { x = x1; label = lab; }
    
    bool operator<(const Point & p) const
    { if(x < p.x) return true;
      if(x > p.x) return false;
      if(label < p.label) return true;
      return false;
    }
};       

Point P[20010];
int n;

int main()
{ int n;
  long a,b;
  
  cin >> n;
  for(int i=0; i<n; i++)
  { cin >> a >> b;
    P[2*i] = Point(a,'L');
    P[2*i+1] = Point(b,'R');
  }  
  
  sort(P,P+(2*n));
    
  long cnt = 0;    
  
  int k = 0;
         
  for(int i=0; i<2*n; i++)
  { 
    if(P[i].label == 'L')
    { k++;
      if(k==1) a = P[i].x;
    }  
    else
    { k--; 
      if(k==0)
      { b = P[i].x;
        cnt = cnt + (b-a+1);
      }  
    }    
  }
  
  cout << cnt << endl;
  return 0;       
}       
