#include <stdlib.h>
#include <stdio.h>
#include <string.h>

int next[100002];
char visited[100002];
int n, m;

void visit( int t );
int find( int t );

int main() {
	next[0] = 0;
	scanf( "%d %d", &n, &m );
	int i;
	visited[0] = 0;
	for ( i = 1; i <=n; ++i ) {
		scanf( "%d", &next[i] );
	}
	int x, y;
	for ( i = 0; i < m; ++i ) {
		memset( visited, 0, (n+1)*sizeof(char) );
		scanf( "%d %d", &x, &y );
		visit( x );
		printf( "%d\n", find( y ) );
	}
	
	return 0;
}

void visit( int t ) {
	while ( t != 0 ) {
		visited[t] = 1;
		t = next[t];
	}
	visited[t] = 1;
}

int find( int t ) {
	while ( visited[t] == 0 ) {
		t = next[t];
	}
	return t;
}

