#include <cstdio>

typedef signed int ind;
typedef long long unsigned int numval;

const numval max = (numval)-1;

const char *read_ind = "%d";
const char *write_ind = "%d";
const char *read_numval = "%llu";
const char *write_numval = "%llu";

bool inline inc_base(const numval& base, numval& cb)
{
	numval old = cb;
	cb *= base; cb++;
	return cb > old;
}

int main()
{
	numval n, cb = 1;
	ind base;
	std::scanf(read_numval, &n);
	std::scanf(read_ind, &base);
	ind i = 1, j;
	bool found = false;
	do
	{
		j = 1;
		numval prev = cb-1;
		for (numval c = cb; j <= base-1; j++)
		{
			if (c < prev) break;
			if (!(c % n))
			{
				found = true;
				cb = max;
				break;
			}
			prev = c;
			c += cb;
		}

		i++;
	}
	while (inc_base(base, cb));
	i--;

	if (!found)
		std::printf("0\n");
	else
	{
		std::printf(write_ind, i);
		std::printf(" ");
		std::printf(write_ind, j);
		std::printf("\n");
	}

	return 0;
}
