# include <stdio.h>
# define MAXN (75000)

int n,m,pr[MAXN];

void print(int k) {
     printf("%d\n", k);
}

void bfs(int a,int b) {
     //printf("solve(%d,%d)\n", a,b);
     
     int queue[MAXN],queue1[MAXN];
     
     int s,s1,end,end1,level,level1;
     int used[MAXN];
     for(int i = 0; i <= n; i++) used[i] = 0;
     
     queue[0] = a;
     queue1[0] = b;
     used[a] = 1;
     used[b] = 1;
     
     s = 0;
     s1 = 0;
     end = 1;
     end1 = 1;
     level = 1;
     level1 = 1;
   
     while(s < end || s1 < end1) {
          if(s < end) {
               for(int i = s; i < level; i++) {
                    int p = pr[queue[i]];
                    if(used[p] == 1) {
                         print(p);
                         return;
                    }
                    if(p!=0)queue[end++] = p;
                    used[p] = 1;

               }
               s = level;
               level = end;
          }
          if(s1 < end1) {
               for(int i = s1; i < level1; i++) {
                    int p1 = pr[queue1[i]];
                    if(used[p1] == 1) {
                        print(p1);
                        return;
                    }
                    if(p1!=0)queue1[end1++] = p1;
                    used[p1] = 1;
               }
               s1 = level1;
               level1 = end1;
          }


     }
     



}

void read() {
     int a,b;
     scanf("%d %d", &n, &m);
     pr[0] = 0;

     for(int i = 1; i <= n; i++) {
          scanf("%d", &pr[i]);
     }
         
     
     for(int i = 1; i <= m; i++) {
         scanf("%d %d", &a, &b);
         bfs(a,b);
     } 
}

int main() {
    read();

return 0;
}
