#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>

using namespace std;

#define MAXN 100010

int g[MAXN];
bool used[MAXN];
int N, M;
int X, Y;

void DFS(int node) {
    if(node == 0) {
        return;
    }
    used[node] = true;
    
    DFS(g[node]);
    
    return;
}

void DFS2(int node) {
    if(node == 0) {
        printf("0\n");
        return;
    }
    if(used[node]) {
        printf("%d\n", node);
        return;
    }
    DFS2(g[node]);
    
    return;
}

int main() {
    scanf("%d%d", &N, &M);
    
    for(int i = 1; i <= N; i++) {
        scanf("%d", &g[i]);
    }
    
    for(int i = 0; i < M; i++) {
        scanf("%d%d", &X, &Y);
        memset(used, false, sizeof(used));
        DFS(X);
        DFS2(Y);
    }
    
    return 0;
}
