#include<cstdio>
#include<algorithm>
#include<cmath>
using namespace std;

const double PI=3.141592;
const int maxp=1000;
int x[2][maxp], y[2][maxp];
double z[2][maxp];
int n[2];

void proj(double ex, double ey, int j)
{
  for(int i=1;i<=n[j];i++) z[j][i]=ex*x[j][i]+ey*y[j][i];
  sort(z[j]+1,z[j]+n[j]+1);
  
// printf("->%d:",j);
// for(int i=1;i<=n[j];i++) printf("%lf ", z[j][i]);
// printf("\n");
  
}

void output(double ex, double ey, double len)
{
 printf("%lf %lf %lf %lf\n",ex*len,ey*len,-ey,ex);
}

int main()
{
  for(int j=0;j<=1;j++)
  {
   scanf("%d",&n[j]);
   for(int i=1;i<=n[j];i++) scanf("%d%d",&x[j][i],&y[j][i]);
  }

  double t=0;
  while(t<=PI+0.1)
   {double ex=sin(t); double ey=cos(t);
    // printf("ex=%lf ey=%lf\n",ex,ey);
    proj(ex,ey,0);proj(ex,ey,1);
    double w1=z[0][n[0]/2];
    double w2=z[0][n[0]/2+1];
    double ws=(w1+w2)/2.0;
    double b1=z[1][n[1]/2];
    double b2=z[1][n[1]/2+1];
    double bs=(b1+b2)/2.0;
    
    if((w1<w2)&&(b1<b2))
    {
    if((w1<bs)&&(bs<w2))
     {output(ex,ey,bs); break;}
    if((b1<ws)&&(ws<b2))
     {output(ex,ey,ws); break;}
    }
    t += 0.01;
   }
}

