// Emil Ibrishimov

#include <cstdio>
#include <set>
#include <cstring>
#include <cstdlib>

using namespace std;

int N, M;

int nei[10000][128];
int neiCnt[10000];
int prev[10000];
char used[10000];
int best[10000];
int count[10000];
int depth[10000];
int ans=0;

void input(void)
{
	int index, a, b;
	
	memset(neiCnt, 0, sizeof neiCnt);
	scanf("%d %d", &N, &M);
	for(index=0; index<M; ++index)
	{
		scanf("%d %d", &a, &b);
		--a;
		--b;
		nei[a][neiCnt[a]++]=b;
		nei[b][neiCnt[b]++]=a;		
	}
}

void dfs(short root)
{
	char index;
	short next;
	
	count[root]=0;
	used[root]=1;
	best[root]=depth[root];
	for(index=0; index<neiCnt[root]; ++index)
	{
		next=nei[root][index];
		if(next==prev[root])
		{
			continue;
		}

		if(best[next]==-1)
		{
			depth[next]=depth[root]+1;
			prev[next]=root;
			dfs(next);
			if(best[next]<depth[root])
			{
				count[root]+=count[next]+1;
			}
			else
			{
				if(count[next]+1>ans)
				{
					ans=count[next]+1;
				}
			}
			if(best[next]<best[root])
			{
				best[root]=best[next];
			}
			
		}
		else
		{
			if(depth[next]<best[root])
			{
				best[root]=depth[next];		
			}
			if(depth[next]<depth[root])
			{
				count[root]++;
			}
		}
	}
	if(best[root]==depth[root])
	{
		if(ans<count[root])
		{
			ans=count[root];
		}
		count[root]=0;
	}
	if(ans<count[root])
	{
		ans=count[root];
	}
}

int calc(void)
{
	int index;
	
	memset(used, 0, sizeof used);
	memset(best, -1, sizeof best);
	ans=0;
	for(index=0; index<N; ++index)
	{
		if(!used[index])
		{
			depth[index]=0;	
			dfs(index);
		}
	}
	return ans;
}

int main(void)
{
	input();
	printf("%d\n", calc());
	return 0;
}
