/*
TASK: bicon
LANG: C++
*/
// Iordan Boev SMG
# include <stdio.h>
# define MAXN (10005)
# define MAXM (1<<20)

int n,m,ans;
struct node {
	int y,next,used;
} data[MAXM];
int used[MAXN],fp,pr[MAXN];
int prenum[MAXN],cnt;
int lowest[MAXN]; 

void add(int a,int b) {
	data[fp].y = b;
	data[fp].next = pr[a];
	pr[a] = fp++;	
}

void read() {
	scanf("%d %d", &n,&m);
	fp = 1;
	cnt = 1;
	int a,b;
	for(int i = 1; i <= m; i++) {
		scanf("%d %d",&a,&b);
		add(a,b);
		add(b,a);	
	}	
}

void dfs(int v) {
	used[v] = 1;
	prenum[v] = cnt++;	
	int p = pr[v];
	while( p > 0) {
		if(used[data[p].y]==0) {
			data[p].used = 1;		
			dfs(data[p].y);
		}
		p = data[p].next;			
	}		
}

void work(int v) {
	used[v] = 1;
	int p=pr[v];
	while(p >0) {
		if(used[data[p].y] == 0 && data[p].used == 1) work(data[p].y);
		p = data[p].next;	
	}
	int t=pr[v],maxl = prenum[v];
	while(t > 0) {
		if(data[t].used == 1 && maxl < lowest[data[t].y]) maxl = lowest[data[t].y];
		else {
			if(prenum[v] < prenum[data[t].y] && maxl < prenum[data[t].y]) maxl = prenum[data[t].y];	
		}
		t = data[t].next;	
	}
	lowest[v] = maxl;	
}
	
void solve() {
	dfs(1);
	for(int i = 0; i <= n; i++) used[i] = 0;
	//for(int i = 1; i <= n; i++) printf("%d ", prenum[i]); printf("\n");	
	work(1);
	//for(int i = 1; i <= n; i++) printf("%d ", lowest[i]); printf("\n");
	for(int i = 2; i <= n; i++) {
		int p = pr[i];
		while(p>0) {
			if(lowest[data[p].y] <= prenum[i]) ans++;
			p = data[p].next;
		}	
	}
	printf("%d\n", ans);
}	
	
int main() {
	read();	
	solve();
	return 0;
}
