
/*
  TASK: pred
  KEYW: dynamical programming
*/

// Complexity: O (n ^ 2)

#include <iostream>
using namespace std;

int a, b, n;
long long am [65536], MOD;

int main ()
{
  cin >> MOD >> n >> a >> b;
  
  am [0] = 1;
  for (int i = a; i <= b; ++i)
    for (int j = 0; j + i <= n; ++j)
    {
      am [i + j] += am [j];
      if (am [i + j] >= MOD)
        am [i + j] -= MOD;
    }
  
  cout << am [n] << endl;
  return 0;
}
