#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define maxN 128
#define sin45 0.7071067811
#define ABS(a) (((a)<0)?(-(a)):(a))

typedef struct point {
        double x,y;
        } point;

point p[2][128];
int list[2][128];
int n1,n2;

double ang = 0.0;
double X,Y;
double t,t1,t2;

int cmpW(const void *a, const void *b)
{
    t1 = (double)p[0][*(int*)a].y * X - (double)p[0][*(int*)a].x * Y;
    t2 = (double)p[0][*(int*)b].y * X - (double)p[0][*(int*)b].x * Y;
    return t1<t2;
}
int cmpB(const void *a, const void *b)
{
    t1 = (double)p[1][*(int*)a].y * X - (double)p[1][*(int*)a].x * Y;
    t2 = (double)p[1][*(int*)b].y * X - (double)p[1][*(int*)b].x * Y;
    return t1<t2;
}

void input()
{
     int i;
     scanf("%d",&n1);
     for (i=0;i<n1;++i) {scanf("%lf%lf",&p[0][i].x,&p[0][i].y);list[0][i]=i;}
     scanf("%d",&n2);
     for (i=0;i<n2;++i) {scanf("%lf%lf",&p[1][i].x,&p[1][i].y);list[1][i]=i;}
}

void solve()
{
     int i;
     qsort(list[0],n1,sizeof(int),cmpW);
     qsort(list[1],n2,sizeof(int),cmpB);
     for (i=0;i<n1;++i) {
         t = (double)p[0][i].y * X - (double)p[0][i].x * Y;
         t = ABS(t);
         if (t < 0.000001) return;
         }
     for (i=0;i<n2;++i) {
         t = (double)p[1][i].y * X - (double)p[1][i].x * Y;
         t = ABS(t);
         if (t < 0.000001) return;
         }
     int pos1,pos2;
     double a1,b1,a2,b2;
     pos1 = n1/2-1; pos2 = n2/2-1;
     a1 = (double)p[0][pos1].y * X - (double)p[0][pos1].x * Y;
     b1 = (double)p[0][pos1+1].y * X - (double)p[0][pos1+1].x * Y;
     a2 = (double)p[1][pos2].y * X - (double)p[1][pos2].x * Y;
     b2 = (double)p[1][pos2+1].y * X - (double)p[1][pos2+1].x * Y;
     if (a1 > b1) {t=a1;a1=b1;b1=t;}
     if (a2 > b2) {t=a2;a2=b2;b2=t;}
     if (a2 > a1) a1 = a2;
     if (b2 < b1) b1 = b2;
     if (a1<b1) {
                t1 = (a1+b1)/2.0; t1 *= -1;
                if (X == 0) {printf("%lf %lf %lf %lf\n",0.0,t1,Y,X); exit(0);}
                if (Y == 0) {printf("%lf %lf %lf %lf\n",t1,0.0,Y,X); exit(0);}
                t2 = (double) -t1 / ABS(X);
                printf("%lf %lf %lf %lf\n",0.0,t2,Y,X);
                exit(0);
                }
}

int main()
{
    input();
    X = 0.0; Y = 1.0; solve();
    X = 1.0; Y = 0.0; solve();
    for (ang=0.0;ang<M_PI;ang+=0.000001) {
        X = cos(M_PI/4.0 + ang); Y = sin(M_PI/4.0 + ang);
        solve();
        X = cos(M_PI/4.0 - ang); Y = sin(M_PI/4.0 - ang);
        solve();
        }
    printf("0 0 0 0\n");
    return 0;
}
