/*
TASK: square
LANG: C++
*/

#include <iostream>
#include <cstdio>
using namespace std;

const int MAXN = 1 << 10;
struct P {
    int x, y;
    P () {}
    P (int _x, int _y): x (_x), y (_y) {}
} b[MAXN][5];

bool a[MAXN][MAXN];
bool u[MAXN];
bool u1[5], u2[5];
int i, j, n;
int q[MAXN];
int d[MAXN];

int cross (P p1, P p2, P p3) {
    return p1.x*(p2.y-p3.y) + p2.x*(p3.y-p1.y) + p3.x*(p1.y-p2.y);
}

bool is () {
    memset (u1, 0 , sizeof(u1));
    memset (u2, 0 , sizeof(u2));
    int p, q, l, m, asd1, asd2, kt = 0, ot = 0;
    int vv = 0;
    //first
    
    
    for (q = 1; q <= 4; q++) {
        int ff=1;
        for (p = 1; p <= 4; p++) {
            l = p+1; if(l==5)l=1;
            if (cross (b[i][p], b[i][l], b[j][q]) <= 0) ff = 0;
        }
        if (ff) vv++;
    }
    //second
    for (p = 1; p <= 4; p++) {
        int ff = 1;
        for (q = 1; q <= 4; q++) {
            m = q+1; if (m == 5) m = 1;
            if (cross (b[j][q], b[j][m], b[i][p]) <= 0) ff = 0;
        }
        if (ff) vv++;
    }
    if (vv > 0) return 1;
    
    for (p = 1; p <= 4; p++) {
        if (p == 4) l = 1; else l = p + 1;
        for (q = 1; q <= 4; q++) {
            if (q == 4) m = 1; else m = q + 1;
            asd1 =  cross (b[i][p], b[i][l], b[j][q]) * cross (b[i][p], b[i][l],b[j][m]);
            asd2 =  cross (b[j][q], b[j][m], b[i][p]) * cross(b[j][q],b[j][m],b[i][l]);
            if ((asd1 < 0) && (asd2 < 0)) return 1;
        }
    }

    //obshti tochki
    for (p = 1; p <= 4; p++)
        for (q = 1; q <= 4; q++)
            if (b[i][p].x == b[j][q].x && b[i][p].y == b[j][q].y){
                ot++;
                u1[p] = 1; u2[q] = 1;
            }
    //konturni
    kt=0;
    int p1,p2;
    for (p = 1; p <= 4; p++) if (!u1[p]) {
        if (p == 4) l = 1; else l = p + 1;
        p1 = p-1; if (p1==0)p1=4;
        p2=l+1;if(p2==5)p2=1;
        for (q = 1; q <= 4; q++) if (!u2[q]) {
            if (cross (b[i][p], b[i][l], b[j][q]) == 0 && cross(b[i][p1],b[i][p],b[j][q]) >0 && cross(b[j][q],b[i][l],b[i][p2])>0) kt++;            
        }
    }
    //printf ("kt-%d\n", kt);
    for (q = 1; q <= 4; q++) if (!u2[q]) {
        if (q == 4) m = 1; else m = q + 1;
        p1=q-1;if(p1==0)p1=4;
        p2=m+1;if(p2==5)p2=1;
        for (p = 1; p <= 4; p++) if (!u1[p]) {
            if (cross (b[j][q], b[j][m], b[i][p]) == 0 &&cross(b[j][p1],b[j][q],b[i][p])>0&&cross(b[i][p],b[j][m],b[j][p2])>0) kt++;
        }
    }
    //printf ("KT = %d\nOT = %d\n", kt, ot);
    //--
    int V = 0;
    
    //------------------
    int f2 = 1; // first contain
        for (q = 1; q <= 4; q++) {
            for (p = 1; p <= 4; p++) {
                if (p == 4) l = 1; else l = p + 1;
                
                if (cross (b[i][p], b[i][l], b[j][q]) < 0) {f2 = 0; break;}
            
            }
            if (!f2) break;
        }
        if (f2) V = 1;
    f2 = 1; // second contain
        for (p = 1; p <= 4; p++) {
            for (q = 1; q <= 4; q++) {
                if (q == 4) m = 1; else m = q + 1;
                
                if (cross (b[j][q], b[j][m], b[i][p]) < 0) {f2 = 0; break;}
            
            }
            if (!f2) break;
        }
        if (f2) V = 1;
    //------------------
    if (ot == 0) {
        if (kt==4)return 1;
        if (V) return 1;
        else return 0;
        
    }
    if (ot == 1) {
        if (kt == 0) return 0;
        if (kt == 1) {//vytre ili vyn
            if (V) return 1;
            else return 0;
        }
        if (kt >= 2) return 1;
    }
    if (ot == 2) {
        for (p = 1; p <= 4; p++) if (b[i][p].x == b[j][0].x && b[i][p].y == b[j][0].y) return 1;// obsht centyr
        for (p = 1; p <= 4; p++) if (b[j][p].x == b[i][0].x && b[j][p].y == b[i][0].y) return 1;// -||-
        return 0;
    }
    if (ot > 2) return 1;
}

void solve () {
    int br = 0, temp = 1;
    q[++br] = 1;
    u[1] = 1;
    while (temp <= br) {
        for (i = 1; i <= n; i++)
            if (a[q[temp]][i] && !u[i]) {
                q[++br] = i;
                d[br] = d[temp] + 1;
                u[i] = 1;
                if (i == n) {
                    //for (i = 1; i <= br; i++) printf ("%d ", d[i]);
                    //printf ("\n");
                    //for (i = 1; i <= br; i++) printf ("%d ", q[i]);
                    //printf ("\n");
                    printf ("%d\n", d[br]);
                    return;
                }
            }
        temp++;
    }
    printf ("-1\n");
}

int main () {
    //freopen ("a1.inp", "rt", stdin);
    //freopen ("a1.out", "wt", stdout);
    scanf ("%d", &n);
    P p, q;
    int d1, d2;
    for (i = 1; i <= n; i++) {
        scanf ("%d %d %d %d", &p.x, &p.y, &q.x, &q.y);
        d1 = p.x - q.x;
        d2 = p.y - q.y;
        b[i][0] = p;
        b[i][1] = P (p.x + d1, p.y + d2); // nachalna
        b[i][2] = P (p.x + d2, p.y - d1);
        b[i][3] = P (p.x - d1, p.y - d2); // protivopolojna na nachalnata
        b[i][4] = P (p.x - d2, p.y + d1);
        // sorting
        if (cross (b[i][1], b[i][2], b[i][3]) < 0) swap (b[i][2], b[i][4]);
    }
    //for (i = 1; i <= 4; i++) printf ("%d %d\n", b[4][i].x, b[4][i].y);
    bool f;
    for (i = 1; i < n; i++)
        for (j = i + 1; j <= n; j++) {
            //printf ("check %d %d\n", i, j);
            if (is ()) a[i][j] = a[j][i] = 1;
            //printf ("return %d\n", a[i][j]);
        }
    solve ();
    return 0;
}
