/*
TASK: subseq 
LANG: C++
*/
#include<iostream>
using namespace std;
int n,a;
long sums[1024 * 1024],sol,s;

int bin_s(long x)
{
 if (x < 0) return 0;
 long l=0,r = n,m;    
 while (l < r)
  {
   if (sums [l] == x) return 1;
   if (sums [r] == x) return 1;
   m = (l + r)/2;
   if (sums [m] == x) return 1;
   if (sums [m] < x) l = m + 1; 
    else r = m - 1;
  }
 return 0;
}

int main()
{
 scanf("%d%ld",&n,&s);
 for(int i=1; i <= n; i++)
  {
   scanf("%d",&a);
   sums [i] = sums[i-1] + a;
   sol += bin_s( sums[i] - s );       
  }
 printf("%ld\n",sol);   
 return 0;    
}
