/*
TASK:alaska
LANG:C++
*/
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <list>
#include <numeric>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <utility>
#include <algorithm>
#include <functional>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define MP make_pair
#define PB push_back
#define x first
#define y second
#define SZ size()
#define ALL(v) (v).begin(),(v).end()
#define LL long long
#define PI pair<int,int>
#define PD pair<double,double>
#define UI unsigned int
#define ULL unsigned LL
#define sign(x) (((x)>0)-((x)<0))
#define ABS(x) (((x)>0)?(x):(-(x)))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define lcm(a,b) ((a)*((b)/__gcd(a,b)))
#define sqr(a) ((a)*(a))
#define pause system("pause")

int N,K,M,n,m;
char tmp[20];

PD one[1024],two[1024]; int oc,tc;

inline double cp(PD &A,PD &B,PD &C)
{
    double dx1=B.x-A.x;
    double dy1=B.y-A.y;
    double dx2=C.x-A.x;
    double dy2=C.y-A.y;
    return dx1*dy2-dx2*dy1;
}

inline bool isin(PD &X,PD &A,PD &B)
{     return (X.x>=min(B.x,A.x) && X.x<=max(A.x,B.x) && X.y>=min(B.y,A.y) && X.y<=max(A.y,B.y));}

inline PD intersect(PD &A,PD &B,PD &C,PD &D)
{
    double num=cp(A,C,D),den=cp(A,C,B)+cp(A,B,D);
    if (!den) return MP(1e100,1e100);
    PD X;
    X.x=A.x+(B.x-A.x)*num/den;
    X.y=A.y+(B.y-A.y)*num/den;
    return X;
}

inline double dist1(PD &A,PD &B)
{ return sqr(A.x-B.x)+sqr(A.y-B.y); }

double bigS(PD a[],int br)
{
    double ret=0;
    Repi(br)
     {
            if (i<br-1)
             ret+=(a[i].x-a[i+1].x)*(a[i].y+a[i+1].y);
            else
             ret+=(a[i].x-a[0].x)*(a[i].y+a[0].y);
     }
    return ret;
}


inline bool ravno(PD &A,PD &B)
{ return fabs(A.x-B.x)<1e-5 && fabs(A.y-B.y)<1e-5; }  //EPS?????????????????????????????????

PD yey[1000000]; int yc;

int main()
{
    bool sec=0;
    PD X;
    while(gets(tmp))
     {
            if (!tmp[0]) { sec=1; continue; }
            sscanf(tmp,"%lf%lf",&X.x,&X.y);
            //cout<<X.x<<" "<<X.y<<" "<<sec<<endl;
            if (sec) two[tc++]=X; else one[oc++]=X;
     }
    if (bigS(one,oc)<0) reverse(one,one+oc);
    if (bigS(two,tc)<0) reverse(two,two+tc);
   // cout<<bigS(one,oc)<<" "<<bigS(two,tc)<<endl; 
    
    one[oc++]=one[0]; two[tc++]=two[0];
   
    
    int oi=-1,ti=-1;
    Repi(tc-1)
    {
     Repj(oc-1)
      {
            X=intersect(two[i],two[i+1],one[j],one[j+1]);
            if (isin(X,two[i],two[i+1]) && isin(X,one[j],one[j+1])) 
             if ( cp(one[j],one[j+1],two[i+1]) > 0 ) //pri suvpadane s vruha na two, se vzema next otse4ka ot two
              {
                    oi=j; ti=i;
                    break;
              }
      }
     if (oi>-1) break;
    }

    
    if (oi==-1)
     { 
       double S2=bigS(two,tc);
       bool vutre=0;
       Repi(oc-1)
        {
            double S=0;
            Repj(tc-1)
             S+=fabs(cp(two[j],two[j+1],one[i]));
            if (fabs(S-S2)<1e-5) vutre=1;
        }
       if (vutre) { printf("%.2lf\n",bigS(one,oc-1)/2.);  return 0; }
           
       //neka se MOLIM 4e nqma da dadat slu4ai sus izpuknaliq da e celiq v naebaniq...
       printf("0\n");
     
       return 0; }
     
    PD init=X;
    yey[yc++]=X;
    PD oX;
    PD &cur=yey[yc-1];
  //  cout<<"add "<<cur.x<<" "<<cur.y<<endl;
    bool ontwo=1;
    while(1)
     {
            if (ontwo)
             {
                    oi=-1;
                    Repi(oc-1)
                     {
                          X=intersect(cur,two[ti+1],one[i],one[i+1]);
                          if (!ravno(X,cur) && isin(X,cur,two[ti+1]) && isin(X,one[i],one[i+1]))  //NE parvata koqto ti padne!!! a nai=blizkata do cur !!!!
                           if (oi==-1 || (oi>-1 && dist1(cur,oX)>dist1(cur,X)))
                            { oX=X; oi=i; }
                     }
                    if (oi==-1)
                     {
                       yey[yc++]=two[++ti]; cur=yey[yc-1];
                     //  cout<<"add "<<yey[yc-1].x<<" "<<yey[yc-1].y<<endl;
                       if (ti==tc-1) ti=0;
                     }
                    else
                     {
                            ontwo=0;
                            yey[yc++]=oX;
                            cur=yey[yc-1];
                        //    cout<<"add "<<cur.x<<" "<<cur.y<<endl;
                        //    cout<<" ON ONE - "<<oi<<endl;
                     }
             }
            else
             {
                    ti=-1;
                    Repi(tc-1)
                     {
                          X=intersect(cur,one[oi+1],two[i],two[i+1]);
                          if (!ravno(X,cur) && isin(X,cur,one[oi+1]) && isin(X,two[i],two[i+1])) 
                           if (ti==-1 || (ti>-1 && dist1(cur,oX)>dist1(cur,X)))
                            { oX=X; ti=i; }
                     }
                    if (ti==-1)
                     {
                       yey[yc++]=one[++oi]; cur=yey[yc-1];
                      // cout<<"add "<<yey[yc-1].x<<" "<<yey[yc-1].y<<endl;
                       if (oi==oc-1) oi=0;
                     }
                    else
                     {
                            ontwo=1;
                            yey[yc++]=oX;
                            cur=yey[yc-1];
                      //      cout<<"add "<<cur.x<<" "<<cur.y<<endl;
                      //      cout<<" ON TWO - "<<ti<<endl;
                     }
             } 
            if (ravno(yey[yc-1],init)) break;
     }
     
    printf("%.2lf\n",bigS(yey,yc-1)/2.);
     
    return 0;
}
