/*
TASK:part
LANG:C++
*/
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <list>
#include <numeric>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <utility>
#include <algorithm>
#include <functional>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define MP make_pair
#define PB push_back
#define x first
#define y second
#define SZ size()
#define ALL(v) (v).begin(),(v).end()
#define LL long long
#define PI pair<int,int>
#define PD pair<double,double>
#define UI unsigned int
#define ULL unsigned LL
#define sign(x) (((x)>0)-((x)<0))
#define ABS(x) (((x)>0)?(x):(-(x)))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define lcm(a,b) ((a)*((b)/__gcd(a,b)))
#define pause system("pause")



int N,K,M,n,m;
int a[32];




bool brute(int pos,int S1,int S2,int S3)
{
    if (pos==N)
     return S1==S2 && S2==S3;
    if (brute(pos+1,S1+a[pos],S2,S3)) return 1;
    if (brute(pos+1,S1,S2+a[pos],S3)) return 1;
    if (brute(pos+1,S1,S2,S3+a[pos])) return 1;
    return 0;
}







const int MAX=1000000; //== max sum /3 *2
bool dp[2][MAX];
int sums[2][MAX],sc[2],S;
bool solve()
{
    S=0;
    Repi(N) S+=a[i];
    if (S%3) return 0;
    S/=3;
    sums[0][sc[0]++]=S; dp[0][S]=1; //offset sumite sus S!!!
    int Y=0,tmp;
    //cout<<S<<endl;
    Repi(N)
     {
            sc[Y^1]=0;
            memset(dp[Y^1],0,sizeof(dp[Y^1])); //slow mada fakkaaa, pone memset sus sumata na 4islata
            Repj(sc[Y])
             {
              tmp=sums[Y][j]+a[i];
              if (tmp<MAX && !dp[Y^1][tmp])
               {
                 dp[Y^1][tmp]=1;
                 sums[Y^1][sc[Y^1]++]=tmp;
               }
              tmp=sums[Y][j]-a[i];
              if (tmp>=0 && !dp[Y^1][tmp])
               {
                 dp[Y^1][tmp]=1;
                 sums[Y^1][sc[Y^1]++]=tmp;
               }
             }
             
            Y^=1;
        //    cout<<":: "<<i<<" -> "; Repi(sc[Y]) cout<<sums[Y][i]-S<<" "; cout<<endl;
     }
    return dp[Y][2*S];
}


int mask;

bool subsetsum()
{
    //cout<<"trying "; Repi(N) if (mask&(1<<i)) cout<<a[i]<<" "; cout<<endl;
    memset(dp[0],0,sizeof(dp[0]));
    sc[0]=sc[1]=0;
    sums[0][sc[0]++]=S; dp[0][S]=1; //offset sumite sus S!!!
    int Y=0,tmp;
    Repi(N)
     if (mask&(1<<i))
     {
            sc[Y^1]=0;
            memset(dp[Y^1],0,sizeof(dp[Y^1])); //slow mada fakkaaa, pone memset sus sumata na 4islata
            Repj(sc[Y])
             {
              tmp=sums[Y][j]+a[i];
              if (tmp<MAX && !dp[Y^1][tmp])
               {
                 dp[Y^1][tmp]=1;
                 sums[Y^1][sc[Y^1]++]=tmp;
               }
              tmp=sums[Y][j]-a[i];
              if (tmp>=0 && !dp[Y^1][tmp])
               {
                 dp[Y^1][tmp]=1;
                 sums[Y^1][sc[Y^1]++]=tmp;
               }
             }
             
            Y^=1;
        //    cout<<":: "<<i<<" -> "; Repi(sc[Y]) cout<<sums[Y][i]-S<<" "; cout<<endl;
     }
    return dp[Y][S];
}

bool solvereal()
{
    int s,S2=2*S;
    //cout<<endl<<"REAL SOL\n";
    for (mask=1;mask<(1<<N)-1;mask++)
     {
           s=0;  Repi(N) s+=((mask>>i)&1)*a[i];
           //Repi(N) if (mask&(1<<i)) cout<<a[i]<<" "; cout<<" = "<<s<<endl;
           if (s==S2 && subsetsum()) return 1;
     }
    return 0;
}

int main()
{
    scanf("%d",&N);
    Repi(N) scanf("%d",a+i);
    
    //cout<<brute(0,0,0,0)<<endl;
    
    if (!solve()) { printf("0\n"); return 0; }
    printf("%d\n",solvereal());
    
    return 0;
}
