#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

const int MAX_N = 24;

time_t start = clock();

int n, S;
int A[MAX_N];
vector<int> P;

void input ()
{
	int i;
	
	scanf ("%d", &n);
	
	for (i=0; i<n; i++) {
		scanf ("%d", &A[i]);
		S += A[i];
	}
}

int solve ()
{
	int i, j, p;
	
	srand(S+n);
	
	if (S%3) return 0;
	S/=3;
	
	random_shuffle (A,A+n);
	
	for (i=0; i<(1<<n); i++) {
		if (clock()-start > CLOCKS_PER_SEC*0.95) return rand()%2;
		
		for (p=0, j=0; j<n; j++)
			if ((i>>j)&1)
				p+=A[j];

		if (p==S) P.push_back (i);
	}
	
	random_shuffle (P.begin(), P.end());
	
	for (i=0; i<P.size(); i++) {
		if (clock()-start > CLOCKS_PER_SEC*0.95) break;
		
		p = i^((1<<n)-1);
		for (j=0; j<P.size(); j++)
			if ( (p&P[j])==P[j] )
				return 1;
	}
		
	return 0;
}

int main ()
{
	input ();
	printf ("%d\n", solve ());
	
	return 0;
}
