#include <cstdio>
#include <queue>
#include <vector>
#define MAX (1<<16)

using namespace std;

typedef struct node {
        char pos;
        char x,y;
        char dir;
        } node;

char used0[22][22][MAX];
char used1[22][22][2][MAX];

char A[22][22];
char AK[22][22];
int n,m;
char sx, sy, ex, ey;

vector < pair<node,int> > q;
vector <char> move;
vector <int> sit;
vector <char> res;

char keys[32][2], br_k;
char doors[32][2], br_d;

char boc[32][3][10];

void input()
{
     int i,j;
     scanf("%d %d\n",&n,&m);
     for (i=0;i<=n+1;++i) for (j=0;j<=m+1;++j) A[i][j] = '_';
     for (i=0;i<=n+1;++i) for (j=0;j<=m+1;++j) AK[i][j] = -1;
     for (i=1;i<=n;++i) {
         for (j=1;j<=m;++j) {
             scanf("%c",&A[i][j]);
             if (A[i][j] == 'S') {A[i][j] = '.'; sx = i; sy = j;}
             if (A[i][j] == 'E') {A[i][j] = '.'; ex = i; ey = j;}
             if (A[i][j] == 'K') {
                A[i][j] = '.'; AK[i][j] = br_k;
                keys[br_k][0] = i;
                keys[br_k][1] = j;
                br_k++;
                }
             if (A[i][j] >= '0' && A[i][j] <= '9') {
                doors[br_k][0] = i;
                doors[br_k][1] = j;
                br_d++;
                }
             }
         scanf("\n");
         }
     char o,u,y;
     for (i=0;i<br_k;) {
         scanf("%c%c",&o,&u);
         if (o == '\n') {++i;continue;}
         if (o == 'O') boc[i][0][u-'0'] = 1;
         if (o == 'C') boc[i][1][u-'0'] = 1;
         if (o == 'T') boc[i][2][u-'0'] = 1;
         scanf("%c",&o);
         if (o == '\n') ++i;
         }
     for (i=0;i<br_d;++i) {
         scanf("%c",&o);
         if (o == '1') A[doors[i][0]][doors[i][1]] = '.';
         else A[doors[i][0]][doors[i][1]] = '_';
         }
}

void bfs()
{
     pair<node,int> p;
     node a,b;
     int i,j,st=0,curs,kx,ky,t,pos;
     
     a.pos = 0; a.x = sx; a.y = sy; a.dir = 0;
     q.push_back(make_pair(a,-1));
     move.push_back('?');
     used0[sx][sy][0] = 1;
     sit.push_back(0);
     
     while (st < q.size()) {
           a = q[st].first;
           curs = sit[st];
           //printf("pop x=%d y=%d pos=%d dir=%d  ",a.x,a.y,a.pos,a.dir);
           
           if (a.x == ex && a.y == ey)
              if (a.pos == 0) {
                 i = st;
                 while (q[i].second != -1) {
                       res.push_back(move[i]);
                       i = q[i].second;
                       }
                 printf("%d\n",res.size());
                 for (i=res.size()-1;i>=0;--i) printf("%c",res[i]);
                 printf("\n");
                 return;
                 }
           
           //printf("sit!!! %d -> ",curs);
           
           kx = a.x; ky = a.y;
           if (AK[kx][ky] >= 0) 
              if (((curs>>AK[kx][ky])&1)==0) {
              for (i=0;i<3;++i)
                  for (j=0;j<10;++j) if (boc[AK[kx][ky]][i][j]) curs |= (1<<AK[kx][ky]);
              }
              
           if (a.pos == 1 && a.dir == 0) {
              kx = a.x+1; ky = a.y;
              if (AK[kx][ky] >= 0) 
              if (((curs>>AK[kx][ky])&1)==0) {
              for (i=0;i<3;++i)
                  for (j=0;j<10;++j) if (boc[AK[kx][ky]][i][j]) curs |= (1<<AK[kx][ky]);
              }
              }
           
           if (a.pos == 1 && a.dir == 1) {
              kx = a.x; ky = a.y+1;
              if (AK[kx][ky] >= 0) 
              if (((curs>>AK[kx][ky])&1)==0) {
              for (i=0;i<3;++i)
                  for (j=0;j<10;++j) if (boc[AK[kx][ky]][i][j]) curs |= (1<<AK[kx][ky]);
              }
              }
           
           //printf("%d",curs);
           
           t=curs,pos=0;
           while (t) {
                 if (t&1) {
                          for (j=0;j<10;++j) {
                              if (boc[pos][0][j]) A[doors[j][0]][doors[j][1]] = '.';
                              if (boc[pos][1][j]) A[doors[j][0]][doors[j][1]] = '_';
                              if (boc[pos][2][j]) {
                                 if (A[doors[j][0]][doors[j][1]] == '_') A[doors[j][0]][doors[j][1]] = '.';
                                 else A[doors[j][0]][doors[j][1]] = '_';
                                 }
                              }
                          }
                 t>>=1; ++pos;
                 }
           
           if (A[a.x][a.y] == '_') {/*printf("kluc!\n"); */goto bau;}
           if (a.pos == 0) if (A[a.x][a.y] == '^') {/*printf("kluc!\n");*/ goto bau;}
           if (a.pos == 1) {
                if (a.dir == 0 && A[a.x+1][a.y] == '_') {/*printf("kluc!\n");*/ goto bau;}
                if (a.dir == 1 && A[a.x][a.y+1] == '_') {/*printf("kluc!\n");*/ goto bau;}
                }
           
           //printf("\n");
           
           if (a.pos == 0) {
              b.pos = 1; 
              if (a.x >= 3) if (!used1[a.x-2][a.y][0][curs]) {
                 b.x = a.x-2; b.y = a.y; b.dir = 0;
                 used1[a.x-2][a.y][0][curs] = 1;
                 q.push_back(make_pair(b,st));
                 move.push_back('u');
                 sit.push_back(curs);
                 }
              if (a.x <= n-2) if (!used1[a.x+1][a.y][0][curs]) {
                 b.x = a.x+1; b.y = a.y; b.dir = 0;
                 used1[a.x+1][a.y][0][curs] = 1;
                 q.push_back(make_pair(b,st));
                 move.push_back('d');
                 sit.push_back(curs);
                 }
              if (a.y >= 3) if (!used1[a.x][a.y-2][1][curs]) {
                 b.x = a.x; b.y = a.y-2; b.dir = 1;
                 used1[a.x][a.y-2][1][curs] = 1;
                 q.push_back(make_pair(b,st));
                 move.push_back('l');
                 sit.push_back(curs);
                 }
              if (a.y <= m-2) if (!used1[a.x][a.y+1][1][curs]) {
                 b.x = a.x; b.y = a.y+1; b.dir = 1;
                 used1[a.x][a.y+1][1][curs] = 1;
                 q.push_back(make_pair(b,st));
                 move.push_back('r');
                 sit.push_back(curs);
                 }
              }
           
           if (a.pos == 1 && a.dir == 0) {
              b.pos = 0;
              if (a.x >= 2) if (!used0[a.x-1][a.y][curs]) {
                 b.x = a.x-1; b.y = a.y;
                 used0[a.x-1][a.y][curs] = 1;
                 q.push_back(make_pair(b,st));
                 move.push_back('u');
                 sit.push_back(curs);
                 }
              if (a.x <= n-2) if (!used0[a.x+2][a.y][curs]) {
                 b.x = a.x+2; b.y = a.y;
                 used0[a.x+2][a.y][curs] = 1;
                 q.push_back(make_pair(b,st));
                 move.push_back('d');
                 sit.push_back(curs);
                 }
              b.pos = 1; b.dir = 0;
              if (a.y >= 2) if (!used1[a.x][a.y-1][0][curs]) {
                 b.x = a.x; b.y = a.y-1;
                 used1[a.x][a.y-1][0][curs] = 1;
                 q.push_back(make_pair(b,st));
                 move.push_back('l');
                 sit.push_back(curs);
                 }
              if (a.y <= m-1) if (!used1[a.x][a.y+1][0][curs]) {
                 b.x = a.x; b.y = a.y+1;
                 used1[a.x][a.y+1][0][curs] = 1;
                 q.push_back(make_pair(b,st));
                 move.push_back('r');
                 sit.push_back(curs);
                 }
              }
           
           if (a.pos == 1 && a.dir == 1) {
              b.pos = 0;
              if (a.y >= 2) if (!used0[a.x][a.y-1][curs]) {
                 b.x = a.x; b.y = a.y-1;
                 used0[a.x][a.y-1][curs] = 1;
                 q.push_back(make_pair(b,st));
                 move.push_back('l');
                 sit.push_back(curs);
                 }
              if (a.y <= m-2) if (!used0[a.x][a.y+2][curs]) {
                 b.x = a.x; b.y = a.y+2;
                 used0[a.x][a.y+2][curs] = 1;
                 q.push_back(make_pair(b,st));
                 move.push_back('r');
                 sit.push_back(curs);
                 }
              b.pos = 1; b.dir = 1;
              if (a.x >= 2) if (!used1[a.x-1][a.y][0][curs]) {
                 b.x = a.x-1; b.y = a.y;
                 used1[a.x-1][a.y][1][curs] = 1;
                 q.push_back(make_pair(b,st));
                 move.push_back('u');
                 sit.push_back(curs);
                 }
              if (a.x <= n-1) if (!used1[a.x+1][a.y][0][curs]) {
                 b.x = a.x+1; b.y = a.y;
                 used1[a.x+1][a.y][1][curs] = 1;
                 q.push_back(make_pair(b,st));
                 move.push_back('d');
                 sit.push_back(curs);
                 }
              }
           
           bau:
           
           t=curs,pos=0;
           while (t) {
                 if (t&1) {
                          for (j=0;j<10;++j) {
                              if (boc[pos][0][j]) A[doors[j][0]][doors[j][1]] = '_';
                              if (boc[pos][1][j]) A[doors[j][0]][doors[j][1]] = '.';
                              if (boc[pos][2][j]) {
                                 if (A[doors[j][0]][doors[j][1]] == '_') A[doors[j][0]][doors[j][1]] = '.';
                                 else A[doors[j][0]][doors[j][1]] = '_';
                                 }
                              }
                          }
                 t>>=1; ++pos;
                 }
           
           ++st;
           }
     printf("0\n");
}

int main()
{
    input();
    bfs();
    return 0;
}
