#include<cstdio>
#include<vector>
#include<queue>
using namespace std;

vector<int> bs[10500], t[1024];
char a[1024][1024];
int d[1024], home[1024], sch[1024], n, m;

int bfs(int s)
{
    int i;
    for(i=0; i<=n; i++) d[i]=-1;
    d[s]=0;
    queue<int> dat; dat.push(s);
    int v;
    while(!dat.empty())
    {
        v=dat.front();
        //printf("%d\n", v);
        dat.pop();
        if(sch[v]) return d[v];
        for(i=1; i<=n; i++) if(a[v][i] && d[i]==-1)
        {
            d[i]=d[v]+1;
            dat.push(i);
        }
    }
    return 10000;
}

int main()
{
    scanf("%d%d", &n, &m);
    int i, j, p, q, s, f;
    for(i=1; i<=n; i++)
    {
        scanf("%d", &p);
        for(j=0; j<p; j++)
        {
            scanf("%d", &q);
            t[i].push_back(q);
            bs[q].push_back(i);
        }
    }
    scanf("%d%d", &s, &f);
    for(i=1; i<=n; i++)
        for(j=0; j<t[i].size(); j++)
        {
            q=t[i][j];
            if(q==s) home[i]=1;
            if(q==f) sch[i]=1;
            for(p=0; p<bs[q].size(); p++)
                a[i][bs[q][p]]=1;
        }
    /* Print rebmat
    for(i=1; i<=n; i++)
    {
        for(j=1; j<=n; j++)
            printf("%d ", a[i][j]);
        printf("\n");
    }
    */
    //for(i=1; i<=n; i++) printf("%d %d\n", home[i], sch[i]);
    int min=10000;
    for(i=1; i<=1024; i++) if(home[i])
    {
        q=bfs(i);
        //printf("%d %d\n", q, min);
        if(q<min) min=q;
    }
    if(min==10000) printf("-1\n");
    else printf("%d\n", min);
    return 0;
}
