#include <stdio.h>
#include <algorithm>

using namespace std;

long long ar[100100];
int N;
long long ans = 0;

int check (long long v) {
    for (int i=N-1; i>0; i--) {
        int l = lower_bound(ar,ar+N,ar[i]-v) - ar;
        int r = upper_bound(ar,ar+N,ar[i]+v) - ar;
        if (r-l > N/2) {
           ans = ar[i];
           return 1;
        }
    }
    return 0;
}

int main () {
    scanf("%d",&N);
    for (int i=0; i<N; i++) {
        scanf("%lld",&ar[i]);
    }
    sort(ar,ar+N);
    long long l = 0;
    long long r = ar[N-1]-ar[0]+1;
    while (l+1 != r) {
          long long mid = (l+r)/2;
          if (check(mid)) r = mid;
          else l = mid;
    }
    printf("%lld\n",ans);
    return 0;
}
