/*
TASK: period
NAME: Petar Ivanov
*/

#include <cstdio>

const int MAX_N = int(2e7) + 1000;

int n;
char s[MAX_N];
int fail[MAX_N];

int ans=-1;

void init ()
{
	int i, p=-1;

	//printf ("Init:\n");

	fail[0] = p;
	for (i=1, n=1; s[i]; i++, n++) {
		while (p!=-1 && s[i]!=s[p+1])
			p=fail[p];

		if (s[i]==s[p+1]) p++;
		fail[i] = p;

		//printf ("%d: %d\n", i, fail[i]);
	}
}

void kmp ()
{
	int i, p=-1;

	//printf ("n=%d KMP:\n", n);

	for (i=1; i<n; i++) {
		while (p!=-1 && s[i]!=s[p+1])
			p=fail[p];

		if (s[i]==s[p+1]) p++;
		if (p>ans) ans=p;

		//printf ("%d: %d\n", i, p);
	}
}

int main ()
{
	//freopen ("period.in", "r", stdin);

	gets (s);
	//printf ("%s\n", s);

	init ();
	kmp ();

	printf ("%d\n", n-ans-1);

	return 0;
}