#include <iostream>
#include <vector>
#include <queue>
using namespace std;
long long flow[600][600];
vector <int> v[600];
queue <int> q;
bool u[600];
long long d[600];
int prev[600];
int gr[257];
#define maxn 257
#define maxlong (long long)(1)<<(long long)(62)
#define sink 2*maxn
#define source 0
int N,K;

long long maxf; 
long long sol;

bool bfs()
	{
		int v1 = sink;
			int i;
				for(i=0;i<sink;i++)
					{
						d[i] = maxlong;
						u[i] = 0;
					}
		d[v1]=0;
		u[v1]=1;
			q.push(v1);
				while(!q.empty())
					{
						v1 = q.front();
							u[v1]=1;
					//	cout<<v1<< "---->" << d[v1] <<endl;	
								int i;
									for(i=0;i<v[v1].size();i++)
										{
											int h = v[v1][i];
											if(flow[h][v1]>0&&!u[h])
												{
													u[h]=1;
													d[h] = d[v1] + 1;
													q.push(h);
												}
										}
								q.pop();
					}		
			return u[source];	
				
	}

void dfs(int v1)
	{
		u[v1]=1;
			int i;
		long long maxi = maxlong;
		int maxv=-1;	
				for(i=0;i<v[v1].size();i++)
					{
						int h = v[v1][i];
						if(u[h]==0 && flow[v1][h] > 0)
							{
								if(d[h]<maxi)
									{
										maxi = d[h];
										maxv = h;
									}
							}
					}
			if(maxv!=-1)
			{
			prev[maxv] = v1;
			dfs(maxv);
			}
	}


void alabala()
	{
			while(bfs())
				{
				//	cout<<"After Bfs"<<endl;
					//memset(u,0,sizeof(u));
						int i;
							for(i=0;i<sink;i++)	
								u[i]=0;
						while(1)
							{
								u[source] = 0;
								prev[source]=-1;
								u[sink] = 0;
								//cout<<"Before dfs"<<endl;
								dfs(source);
							//	cout<<"After dfs"<<endl;
								//cout<<u[sink]<<endl;
								if(u[sink] == 1)
									{
										int t = sink;
										long long maxi = maxlong;
											while(prev[t]!=-1)
												{
											//		cout<<t<<" ---> ";
													maxi = min(maxi,flow[prev[t]][t]);
													t=prev[t];
												}
											//	cout<<t <<" -------------> "<< maxi <<endl;
											//	cout<<endl;
											sol += maxi;
											t = sink;
											while(prev[t]!=-1)
												{
													flow[prev[t]][t] -= maxi;
													flow[t][prev[t]] += maxi;
													t=prev[t];
												}
									}
									else break;
							}
				}
	}


int main()
{
		scanf ( "%d %d",&N,&K);
		int i;
			for(i=1;i<=N;i++)
				{
					scanf("%d",&gr[i]);
					maxf += (long long)(gr[i]);
					v[i+maxn].push_back(sink);
					v[sink].push_back(i+maxn);
					flow[i+maxn][sink] += (long long)(gr[i]);
				//	v[2*maxn].push_back(i+maxn);
				}	
			for(i=1;i<=K;i++)
			{	
				int dist;
			
					scanf("%d",&dist);
				v[source].push_back(i);
				v[i].push_back(0);
				flow[source][i] = dist;
						int brd;
						int j;
							scanf("%d",&brd);
								for(j=1;j<=brd;j++)
									{
										int t1;
											scanf("%d",&t1);
											v[i].push_back(t1+maxn);
											v[t1+maxn].push_back(i);
											flow[i][t1+maxn] +=(long long)(dist);
									}
			}	
			alabala();
			if(sol >= maxf ) cout<<"Yes"<<endl;
			else cout<<"No"<<endl;
			//cout<<sol<<endl;
			/*for(i=1;i<=3;i++)
				{
					cout<<"bla"<<endl;
					cout<<"Vertex--->"<<i<<endl;
					cout<<flow[i][258]<<endl;
					cout<<flow[258][i]<<endl;
		
				}*/
		//	cout<<bfs()<<endl;
			//cout<<(long long)(maxlong)<<endl;
			//cout<<maxf<<endl;
    return 0;
}
