
/*
    FROM: National Olympiad, 2008, K4
    PROB: period
    KEYW: kmp
*/

#include <cstdio>
#include <algorithm>
using namespace std;

int n;
int a [131072];
int b [131072];

inline int myabs (int x) 
{
    return (x > 0 ? x : -x);
}
void input ()
{
    scanf ("%d", &n);
    for (int i = 0; i < n; ++i)
        scanf ("%d", &a [i]);
}
int brute ()
{
    int med = 2147483647;
    int res = -1;
    sort (a, a + n);
    for (int i = 0; i < n; ++i)
    {
        int k = 0;
        for (int j = 0; j < n; ++j)
            if (i != j)
                b [k ++] = myabs (a [i] - a [j]);
        // change with nth_element
        sort (b, b + k);
        //for (int j = 0; j < k; ++j)
        //    printf ("%d ", b [j]);
        //puts ("");
        //printf ("%d -> med %d\n", a [i], b [k / 2]); 
        if (b [k / 2] <= med)
        {
            med = b [k / 2];
            res = a [i];
        }
//        printf ("%d ", b [k / 2]);
    }
//    puts ("");
    return res;
}
int main ()
{
    input ();
//    brute ();
    printf ("%d\n", brute ());
    return 0;
}
