#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <queue>

#define f(i, n) 					for(int i = 0 ; i < (n); i ++)
#define ff(i, st, end)				for(int i = (st); i < (end); i ++)

void ex(std::string s)
{
//	printf("%s\n", s.c_str());
	std :: cout << s << "\n";
	exit(0);
}

const int INF = 1LL << 30LL;
const int SOURCE = 0;
int SINK;

int N, K, cur;
bool a[550][550];
int adj[550][550];
int cap[550][550];
int top[550];
long long sumgen = 0, sumsol = 0;
int U = 1 << 30;

int dist[550];
int countdist[550];
int active[550];
int vertex;


int parent[550];
bool used[550];
void rev_bfs()
{
	std::queue<int> q;
	q.push(SINK);
	used[SINK] = 1;
	dist[SINK] = 0;
	countdist[0] ++;
	while( !q.empty() )
	{
		int cur = q.front(); q.pop();
		f(i, top[cur])	if( (cap[cur][ adj[cur][i] ] == 0) && (used[ adj[cur][i] ] == 0) )
		{
			q.push( adj[cur][i] );
			used[ adj[cur][i] ] = 1;
			dist[ adj[cur][i] ] = dist[cur] + 1;
			countdist[ dist[cur] + 1 ] ++;
		}
	}
}

int relabel()
{
//	std::cout << "relabel " << vertex << "\n";
	int mn = 2000;
	f( i, top[vertex] )
		if( cap[vertex][ adj[vertex][i] ] > 0 )
			mn = std::min( mn, dist[ adj[vertex][i] ] );
	
	int bu = dist[vertex];
	countdist[ bu ] --;
	countdist[ mn + 1 ] ++;
	dist[ vertex ] = mn + 1;
	active[vertex] = 0;
	if(vertex != SOURCE)
		vertex = parent[vertex];
	return countdist[bu];
}

int push_relabel()
{
	rev_bfs();
//	f(i, SINK + 1)	std::cout << dist[i] << " dist before\n";
	parent[SOURCE] = -1;
	int flow = 0;
	f(i, SINK + 1) active[i] = 0;
	vertex = SOURCE;
	while( dist[SOURCE] <= SINK )
	{
//		std :: cout << dist[SOURCE] << "\n";
//		system("pause");
		if( vertex == SINK )
		{
			int cp = INT_MAX;
			for( int i = SINK, j = parent[i]; j != -1; i = j, j = parent[i] )
				cp = std :: min( cp, cap[j][i] );
			for( int i = SINK, j = parent[i]; j != -1; i = j, j = parent[i] )
			{
//				std::cout << j << " " << i << " " << cp << " wtf\n";
				cap[j][i] -= cp;
				cap[i][j] += cp;
			}
			flow += cp;
			vertex = SOURCE;
		}
//		std::cout << vertex << " vert\n";
		bool ok = 0;
		ff(i, active[vertex], top[vertex])
			if( (dist[vertex] == dist[ adj[vertex][i] ] + 1) && (cap[vertex][ adj[vertex][i] ]) )
			{
				active[vertex] = i;
				parent[ adj[vertex][i] ] = vertex;
				vertex = adj[vertex][i];
				ok = 1;
				break;
			}
		if( ok == 0 )
		{
			int val = relabel();
			if( !val )	return flow;
		}
	}
	return flow;
}



int main()
{
	scanf("%d %d", &N, &K);
	SINK = N + K + 1;
	ff(i, 1, N + 1)
	{
		scanf("%d", &cap[ SOURCE ][ i ]);
		sumsol += cap[ SOURCE ][ i ];
		cap[i][SOURCE] = 0;
		a[SOURCE][i] = 1;
		adj[SOURCE][ top[ SOURCE ] ++ ] = i;
		adj[ i ][ top[i] ++ ] = SOURCE;
	}
	ff(i, 1, K + 1)
	{
		scanf("%d", &cap[ i + N ][SINK]);
		a[i + N][SINK] = 1;
		adj[i + N][ top[ i + N ] ++ ] = SINK;
		adj[SINK][ top[SINK] ++ ] = i + N;
		sumgen += cap[ i + N ][SINK];
		int cnt;
		scanf("%d", &cnt);
		f(j, cnt)
		{
			int cur;
			scanf("%d", &cur);
			cap[ cur ][ i + N ] = INF;
			a[cur][i + N]		= 1;
			adj[ cur ][ top[ cur ] ++ ]	= i + N;
			adj[i + N][ top[ i + N ] ++ ] = cur;
		}
	}
	if( sumgen < sumsol )	ex("No");
	
//	f(i, SINK + 1)	f( j, top[i] ){ std::cout << i << " " << adj[i][j] << " " << cap[i][ adj[i][j] ] << "\n"; }
	

	int t = push_relabel();	
//	f(i, SINK + 1)	std::cout << dist[i] << " dist\n";
//	std::cout << t << "\n";
	if( t == sumsol )	ex("Yes");
	else				ex("No");
	
    return 0;
}
