#include <cstdio>
#include <algorithm>

const int MAXK = 1 << 9;
const int MAXN = 1 << 6;

int n , k , t , p;

int bad[4][4][4];
int a[MAXN];

int dp[2][MAXN][MAXK][4][4];

void read() {
    char buf[4];
    int i;
    
    scanf ("%d%d%d%d",&n,&k,&t,&p);
    
    for (i=1;i<=p;i++) {
        scanf ("%s",buf);
        bad[ buf[0] - '0' ][ buf[1] - '0' ][ buf[2] - '0' ] = 1;
    }
}

void solve() {
    int i , j , d , q , w;
    int x , y;
    int ans = 0;
    
    memset ( dp , -1 , sizeof dp );
    
    scanf ("%d",&j);
    while ( j -- ) {
        scanf ("%d%d",&x,&y);
        a[x] = y;
    }
    
    for (i=1;i<=n;i++) {
        if ( i != 1 ) {
            dp[0][i - 1][k - 1][0][1] = a[i - 1];
            
            if ( dp[0][i - 1][k - 1][0][1] > ans )
                ans = dp[0][i - 1][k - 1][0][1];
        }
            
        dp[0][i][k][0][0] = a[i];
        if ( dp[0][i][k][0][0] > ans )
            ans = dp[0][i][k][0][0];
        
        if ( i != n ) {
            dp[0][i + 1][k - 1][0][2] = a[i + 1];
            
            if ( dp[0][i + 1][k - 1][0][2] > ans )
                ans = dp[0][i + 1][k - 1][0][2];
        }
    }
    
    for (d=2;d<=t;d++) {
        memset ( a , 0 , sizeof a );
        
        scanf ("%d",&j);
        while ( j -- ) {
            scanf ("%d%d",&x,&y);
            a[x] = y;
        }
        
        for (i=1;i<=n;i++)
            for (j=0;j<=k;j++) 
                for (q=0;q<=3;q++)
                    for (w=0;w<3;w++)
                        if ( dp[0][i][j][q][w] != -1 ) {
                                
                            if ( i != 1 && j && !bad[q][w][1] ) {
                                x = dp[0][i][j][q][w] + a[i - 1];
                                
                                if ( x > dp[1][i - 1][j - 1][w][1] ) 
                                    dp[1][i - 1][j - 1][w][1] = x;
                            }
                                
                            if ( !bad[q][w][0] ) {
                                x = dp[0][i][j][q][w] + a[i];
                                    
                                if ( x > dp[1][i][j][w][0] )
                                    dp[1][i][j][w][0] = x;
                            }
                            
                            if ( i != n && j && !bad[q][w][2] ) {
                                x = dp[0][i][j][q][w] + a[i + 1];
                                
                                if ( x > dp[1][i + 1][j - 1][w][2] )
                                    dp[1][i + 1][j - 1][w][2] = x;
                            }
                        }
        
        for (i=1;i<=n;i++)
            for (j=0;j<=k;j++)
                for (q=0;q<3;q++)
                    for (w=0;w<3;w++) {
                        if ( dp[1][i][j][q][w] > ans )
                            ans = dp[1][i][j][q][w];
                        
                        dp[0][i][j][q][w] = dp[1][i][j][q][w];
                        dp[1][i][j][q][w] = -1;
                    }
    }
    
    printf ("%d\n",ans);
}

int main() {
    read();
    solve();
    
    return 0;
}
