#include <iostream>
#include <cmath>
using namespace std;

const int MAX_N = 100000;

int N, M;
int h[MAX_N];

void Read()
{
	scanf("%d %d", &N, &M);
}

double Calc_Area(const int first, const int second)
{
double ret = 0;
	
	for(int i = first; i < second; i ++)
	{
		ret += (h[i + 1] + h[i]) * 0.5;
	}
	
	return ret;
}

void Change_Hight(const int x, const int hight)
{
	if(h[x] < hight)
	{
		for(int i = x, now = hight; i <= N; i ++, now --)
		{
			if(h[i] == now) break;
			else h[i] = now;
		}
		
		for(int i = x - 1, now = hight - 1; 0 <= i; i --, now --)
		{
			if(h[i] == now) break;
			else h[i] = now;
		}
	}
	
	if(hight < h[x])
	{
		for(int i = x, now = hight; i <= N; i ++, now ++)
		{
			if(h[i] == now) break;
			else h[i] = now;
		}
		
		for(int i = x - 1, now = hight + 1; 0 <= i; i --, now ++)
		{
			if(h[i] == now) break;
			else h[i] = now;
		}
	}
}

void Solve()
{
	for(int i = 0; i <= N; i ++)
	{
		h[i] = i & 1;
	}
	
	for(int i = 0; i < M; i ++)
	{
		int command, first, second;
		
		scanf("%d %d %d", &command, &first, &second);
		
		if(command == 1)
		{
			Change_Hight(first, second);
		}
		
		if(command == 2)
		{
			double area = Calc_Area(first, second);
			
			if(abs(area - floor(area)) < 1e-4) printf("%d\n", int(area + 1e-4));
			else printf("%.1lf\n", area);
		}
	}
}

int main()
{
	Read();
	
	Solve();
	
	return 0;
}

