#include <cstdio>
#include <vector>
#include <algorithm>
#define maxN 500005

using namespace std;

int n,m,k;
vector < pair<int,int> > G[maxN];
int dist[maxN], pos[maxN];
vector <int> q,last;
int group[55],br;
int path[maxN];
vector <int> SS[55];

void input()
{
     scanf("%d%d%d",&n,&m,&k);
     int a,b,c;
     for (int i=0;i<m;++i) {
         scanf("%d%d%d",&a,&b,&c);
         G[a].push_back(make_pair(b,c));
         }
}

void pre()
{
     int i,j,st=0;
     q.push_back(1);
     last.push_back(-1);
     
     while (st < q.size()) {
           pos[q[st]] = st;
           for (i=0;i<G[q[st]].size();++i) {
               q.push_back(G[q[st]][i].first);
               last.push_back(st);
               dist[G[q[st]][i].first] = dist[q[st]] + G[q[st]][i].second;
               }
           ++st;
           }
}

void load(int p)
{
     int i,pp;
     pp = pos[group[p]];
     while (last[pp] != -1) {
           SS[p].push_back(q[pp]);
           pp = last[pp];
           }
     SS[p].push_back(1);
     reverse(SS[p].begin(),SS[p].end());
     //for (i=0;i<memo[p].size();++i) printf("%d ",memo[p][i]);
     //printf("\n");
}

void solve()
{
     int i,j,res=0;
     memset(path,0,(n+5)*sizeof(int));
     for (i=0;i<br;++i) {
         SS[i] = vector <int> ();
         load(i);
         }
     /*for (i=0;i<br;++i) {
         for (j=0;j<SS[i].size();++j) printf("%d ",SS[i][j]);
         printf("\n");
         }*/
     for (i=0;i<br;++i)
         for (j=0;j<SS[i].size();++j) ++path[SS[i][j]];
     //for (i=1;i<=n;++i) printf("path[%d]=%d\n",i,path[i]);
     for (i=0;i<br;++i) {
         for (j=0;j<SS[i].size();++j) 
             if (path[SS[i][j]] < 2) {
                res += (dist[group[i]]-dist[SS[i][j-1]]/2);
                break;
                }
         if (j == SS[i].size()) res += dist[group[i]]/2;
         }
     printf("%d\n",res);
}

int main()
{
    int i,j;
 		input();
 		pre();
 		for (i=0;i<k;++i) {
        scanf("%d",&br);
        for (j=0;j<br;++j) scanf("%d",&group[j]);
        if (br == 1) printf("%d\n",dist[group[0]]); 
        else solve();
        }
        
 		return 0;
}
