#include <algorithm>
#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

int N, Q, x, y;
vector<int> d, v, pd;
vector<double> t;

double cas(int x) {
  int usek = max(0L, lower_bound( pd.begin(), pd.end(), x ) - pd.begin() - 1 );
  int part = x - pd[usek];
  return t[usek] + (1. * part / v[usek]);
}

int main() {
  cin >> N;
  d.resize(N); v.resize(N);
  for (int n=0; n<N; ++n) cin >> d[n];
  for (int n=0; n<N; ++n) cin >> v[n];
  t.resize(N+1);
  t[0] = 0;
  for (int n=0; n<N; ++n) t[n+1] = t[n] + ( 1. * d[n] / v[n] );
  pd.resize(N+1);
  pd[0] = 0;
  for (int n=0; n<N; ++n) pd[n+1] = pd[n] + d[n];
  // cerr << pd[N] << endl;
  cin >> Q;
  while (Q--) {
    cin >> x >> y;
    printf("%.10f\n",cas(y)-cas(x));
  }
}
