#include <algorithm>
#include <numeric>
#include <cstdio>
#include <vector>
#include <string>
using namespace std;

class sutaziaci { public: string meno; int body; };

bool operator< (const sutaziaci &A, const sutaziaci &B) {
  if (A.body != B.body) return A.body > B.body;
  return A.meno < B.meno;
}

int main() {
  int S, R;
  scanf("%d%d",&S,&R);
  vector<sutaziaci> vysledky(S);
  for (int s=0; s<S; ++s) {
    char buf[12];
    scanf("%s",buf);
    vysledky[s].meno = buf;
    vector<int> znamky(R);
    for (int r=0; r<R; ++r) scanf("%d",&znamky[r]);
    vysledky[s].body 
      = accumulate( znamky.begin(), znamky.end(), 0 )
      - *max_element( znamky.begin(), znamky.end() )
      - *min_element( znamky.begin(), znamky.end() );
  }
  for (int s=0; s<S; ++s)
    for (int t=s+1; t<S; ++t)
      if (vysledky[t]<vysledky[s])
        swap(vysledky[t],vysledky[s]);
  for (int s=0; s<S; ++s) printf("%d: %s\n",vysledky[s].body,vysledky[s].meno.c_str());
}

