type sutaziaci = record 
                    meno: string; 
                    body: longint;
                 end; 

var S, R : longint;
    vysledky : array[1..100047] of sutaziaci;
    i, j, max, min, cur : longint;

procedure swap(var x, y : longint);
var z : longint;
begin z:=x; x:=y; y:=z; end;

procedure swap(var x, y : sutaziaci);
var z : sutaziaci;
begin z:=x; x:=y; y:=z; end;

function horsi(var x, y : sutaziaci) : boolean;
begin
   if x.body <> y.body then horsi:=(x.body < y.body) else horsi:=(x.meno > y.meno);
end;

procedure insert(i : longint);
begin
   while (i>1) and (horsi(vysledky[i],vysledky[i div 2])) do begin
      swap( vysledky[i div 2], vysledky[i] );
      i := i div 2;
   end;
end;

procedure extract(pocet : longint);
var i, j : longint;
begin
   swap( vysledky[1], vysledky[pocet] );
   dec(pocet);
   i := 1;
   while true do begin
      j := i;
      if (2*i <= pocet) and (horsi(vysledky[2*i],vysledky[j])) then j:=2*i;
      if (2*i+1 <= pocet) and (horsi(vysledky[2*i+1],vysledky[j])) then j:=2*i+1;
      if j=i then break;
      swap( vysledky[i], vysledky[j] );
      i := j;
   end;
end;

begin
   { nacitame pocet sutaziacich a pocet rozhodcov }
   readln(S,R);

   { pre kazdeho sutaziaceho:
     * nacitame znamky ktore dostal
     * pocas nacitavania si pamatame doteraz najmensiu, najvacsiu a sucet ostatnych }
   for i:=1 to S do begin
      readln(vysledky[i].meno);
      vysledky[i].body := 0;
      read(max); 
      read(min);
      if (max < min) then swap(max,min);
      for j:=3 to R do begin
         read(cur);
         if (cur > max) then begin
            vysledky[i].body := vysledky[i].body + max;
            max := cur;
         end else if (cur < min) then begin
            vysledky[i].body := vysledky[i].body + min;
            min := cur;
         end else begin
            vysledky[i].body := vysledky[i].body + cur;
         end;
      end;
      readln;
   end;

   { utriedime a vypiseme vysledky }
   for i:=2 to S do insert(i);
   for i:=S downto 2 do extract(i);
   for i:=1 to S do writeln(vysledky[i].body,': ',vysledky[i].meno);
end.
