
const P : longint = 1000000009;
var R, S, N, K, i, j: longint;
    fact, inverse : array[0..234567] of longint;
    prekazky : array[0..123,0..1] of longint;
    cesty : array[0..123] of int64;
    tmp : int64;

function modexp(number, power, modulus : int64) : int64;
var hlp : int64;
begin
   if power=0 then modexp:=1
   else if power=1 then modexp:=number
   else begin
      hlp := modexp(number, power div 2, modulus);
      hlp := (hlp * hlp) mod modulus;
      if power mod 2 = 1 then hlp := (hlp * number) mod modulus;
      modexp := hlp;
   end;
end;

procedure swap(var a, b : longint);
var c : longint;
begin c:=a; a:=b; b:=c; end;

function C(a, b: longint) : longint;
var hlp : int64;
begin
   if (a<0) or (b<0) then begin C:=0; exit; end;
   hlp := fact[a+b]; 
   hlp := (hlp * inverse[a]) mod P;
   hlp := (hlp * inverse[b]) mod P;
   C := hlp;
end;

begin
   read(R,S,N);
   fact[0]:=1; fact[1]:=1;
   for i:=2 to R+S+1 do begin tmp:=fact[i-1]; fact[i]:=(tmp*i) mod P; end;
   for i:=0 to R+S+1 do inverse[i]:=modexp( fact[i], P-2, P );
   while N>0 do begin
      dec(N);
      read(K);
      for i:=0 to K-1 do read( prekazky[i][0], prekazky[i][1] );
      for i:=0 to K-1 do
         for j:=i+1 to K-1 do
            if prekazky[i][0]+prekazky[i][1] > prekazky[j][0]+prekazky[j][1] then begin
               swap( prekazky[i][0], prekazky[j][0] );
               swap( prekazky[i][1], prekazky[j][1] );
            end;
      prekazky[K][0]:=R; prekazky[K][1]:=S;
      for i:=0 to K do begin
         cesty[i] := C( prekazky[i][0], prekazky[i][1] );
         for j:=0 to i-1 do cesty[i] := ( cesty[i] - cesty[j] * C( prekazky[i][0]-prekazky[j][0], prekazky[i][1]-prekazky[j][1] ) ) mod P;
         cesty[i] := (cesty[i] + P) mod P;
      end;
      writeln( cesty[K] );
   end;
end.
