#include <stdio.h>
#include <string.h>
#include <vector>
#include <set>

using namespace std;

#define NMAX 5012

vector<int> f[NMAX];
multiset<int> s;
multiset<int>::iterator it;
int tata[NMAX], red[NMAX], path[NMAX];
int i, j, k, q, N, P, R, cost;

void df(int x, int lev)
{
	int y;

	if (red[x] == 0)
		s.insert(lev - i);

	for (y = 0; y < f[x].size(); y++)
		if (red[f[x][y]] <= 1)
			df(f[x][y], lev + 1);
}

int main()
{
	freopen("bile7.in", "r", stdin);
	freopen("bile7.out", "w", stdout);

	scanf("%d %d %d", &N, &P, &R);

	memset(tata, 0, sizeof(tata));
	for (i = 1; i <= N; i++)
	{
		scanf("%d", &k);
		for (j = 1; j <= k; j++)
		{
			scanf("%d", &q);
			f[i].push_back(q);
			tata[q] = i;
		}
	}

	memset(red, 0, sizeof(red));
	for (i = 1; i <= R; i++)
	{
		scanf("%d", &q);
		red[q] = 1;
	}

	red[P] = 2;

	if (P == 1)
	{
		printf("0\n");
	}
	else
	{
		path[R = 1] = tata[P];
		while (path[R] != 1)
		{
			R++;
			path[R] = tata[path[R - 1]];
		}

		for (i = 1; i <= R; i++)
			red[path[i]] += 3;

		s.clear();

		cost = 0;
		for (i = 1; i <= R; i++)
		{
			df(path[i], 0);

			if (red[path[i]] == 3)
				continue;

			if (s.size() == 0)
			{
				cost = -1;
				break;
			}
			else
			{
				it = s.begin();
				//fprintf(stderr, "%d: move cost=%d (#alternatives=%d)\n", i, i + *it, s.size());
				cost += (i + *it);
				s.erase(it);
			}
		}

		printf("%d\n", cost);
	}

	return 0;
}
