/*
 * Author: Andrei Homescu
 * Brute force solution, O(N^2), 40 points
 */
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <cstdarg>
#include <cstring>
#include <cctype>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <utility>
#include <string>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <stack>
#include <set>
#include <map>

using namespace std;

#define	REP( i, n )         for( (i) = 0 ; (i) < (n) ; (i)++ )
#define	IREP( i, n )	    for( (i) = (n) - 1 ; (i) >= 0 ; (i)-- )
#define REPV( i, a, b )     for( (i) = (a) ; (i) <= (b) ; (i)++ )
#define IREPV( i, a, b )    for( (i) = (b) ; (i) >= (a) ; (i)-- )
#define REPIT( it, x )      for( (it) = (x).begin( ) ; (it) != (x).end( ) ; (it)++ )
#define ALL( x )            (x).begin( ), (x).end( )
#define MP                  make_pair
#define PB                  push_back
#define CLR( x )            memset( (x), 0, sizeof( x ) )
#define CLRV( x, v )        memset( (x), (v), sizeof( x ) )
#define CPY( y, x )         memcpy( (y), (x), sizeof( x ) )
#define	X                   first
#define Y                   second

typedef long long Ll;
typedef pair< int, int > Pii;
typedef pair< Ll, Ll > Pll;
typedef vector< int > Vi;
typedef vector< Ll > Vl;
typedef vector< string > Vs;

const int MAXN = 131072, INF = 0x3f3f3f3f;
const Ll INFL = 0x3f3f3f3f3f3f3f3fLL;
const double EPS = 1e-9;
int n, k;
//double a[MAXN];
float a[MAXN];
    
int main( )
{
    freopen( "geom2.in", "r", stdin );
    freopen( "geom2.out", "w", stdout );

    int i, j;
    scanf( "%d%d", &n, &k );
    for( i = 0 ; i < n ; i++ )
        scanf( "%f", &a[i] );

    float mmax = -1e200, cprod, rt;
    int imax = -1, jmax = -1;
    for( i = 0 ; i < n ; i++ )
    {
        cprod = 0.0f;
        for( j = i ; j < n ; j++ )
        {
            cprod += logf( a[j] );
            rt = cprod / (j - i + 1);
            if( j >= i + k - 1 && rt > mmax )
                mmax = rt, imax = i, jmax = j;
        }
    }
//    printf( "%.6lf\n", exp( mmax ) );
    printf( "%d %d\n", imax + 1, jmax + 1 );
    return 0;    
}
